-- regular annots are in the form {mapid, ns, ew, type, allegiance, stringIndex, "", data, 0, 0, 0}
-- annotations array is in the form {mapid, ns, ew, type, allegiance, mapStringsIndex, resolvedName:Desc, , , , , }
-- custom annots are in the form {mapid, ns, ew, type, allegiance, name:desc, data, 0, 0, 0}

if importPath==nil then importPath=string.gsub(getfenv(1)._.Name,"%.AnnotationsWindow","").."." end
if resourcePath==nil then resourcePath=string.gsub(importPath,"%.","/").."Resources/" end

annotWindow = Turbine.UI.Lotro.Window();
annotWindow:SetText(Resource[Settings.language][72]);
annotWindow:SetVisible(false);
annotWindow:SetSize(500,452);
annotWindow:SetPosition((Turbine.UI.Display:GetWidth() - annotWindow:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - annotWindow:GetHeight()) / 2);

annotWindow.AnnotationIndex=0;
annotWindow.HadErrors=false;
annotWindow.AnnotationsPanel=Turbine.UI.Control();
annotWindow.AnnotationsPanel:SetParent(annotWindow);
annotWindow.AnnotationsPanel:SetSize(annotWindow:GetWidth()-30,annotWindow:GetHeight()-80);
annotWindow.AnnotationsPanel:SetPosition(15,40);
annotWindow.AnnotationsPanel:SetBackColor(Settings.backColor);
annotWindow.AnnotationsPanel:SetMouseVisible(false);

annotWindow.AnnotationCaption=Turbine.UI.Label();
annotWindow.AnnotationCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AnnotationCaption:SetPosition(10,3);
annotWindow.AnnotationCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.AnnotationCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AnnotationCaption:SetForeColor(Settings.fontColor);
annotWindow.AnnotationCaption:SetText(Resource[Settings.language][73]..":");
annotWindow.AnnotationCaption:SetMouseVisible(false);

annotWindow.AnnotationList=DropDownList();
annotWindow.AnnotationList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AnnotationList:SetPosition(annotWindow.AnnotationCaption:GetLeft()+annotWindow.AnnotationCaption:GetWidth()+2,annotWindow.AnnotationCaption.GetTop()-3);
annotWindow.AnnotationList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AnnotationCaption:GetWidth()+annotWindow.AnnotationCaption:GetLeft())-58,20);
annotWindow.AnnotationList:SetFont(Turbine.UI.Lotro.Font.Verdana16)
annotWindow.AnnotationList:SetBorderColor(Settings.trimColor);
annotWindow.AnnotationList:SetTextColor(Settings.listTextColor)
annotWindow.AnnotationList:SetBackColor(Settings.backColor);
annotWindow.AnnotationList:SetCurrentBackColor(Settings.backColor);
annotWindow.AnnotationList:SetDropRows(5);
if Settings.currentMapID~=nil and mapInfo[Settings.currentMapID]~=nil then
	annotWindow.region=mapInfo[Settings.currentMapID][12] -- ?? reported load errors? Settings.currentMapID should be valid at this point. and mapInfo should be valid as well...
else
	region=1
end

--annotWindow.ListPrompt=Turbine.UI.Lotro.Button()
annotWindow.ListPrompt=Turbine.UI.Button()
annotWindow.ListPrompt:SetParent(annotWindow.AnnotationsPanel)
annotWindow.ListPrompt:SetSize(26,20)
annotWindow.ListPrompt:SetPosition(annotWindow.AnnotationList:GetLeft()+annotWindow.AnnotationList:GetWidth()+2,annotWindow.AnnotationList:GetTop())
annotWindow.ListPrompt:SetBackground(resourcePath.."blankbutton.jpg")
annotWindow.ListPrompt:SetText("...")
annotWindow.ListPrompt.Click=function()
	annotWindow.ListPanel:SetVisible(true)
	annotWindow.AnnotationsPanel:SetVisible(false)
end

annotWindow.origNS=nil
annotWindow.origEW=nil
annotWindow.origType=nil
annotWindow.origData=nil
annotWindow.origAllegiance=nil
annotWindow.origName=nil
annotWindow.origDesc=nil
annotWindow.cmdList={}
annotWindow.SynchList=function()
	-- resynch the multi-list after any changes to the dropdown list
	annotWindow.AnnotMultiList:ClearItems()
	local tmpMultiIndex=1
	-- start at index=2 to skip "New"
	for tmpIndex=2,annotWindow.AnnotationList.ListData:GetItemCount() do
		local tmpItem=annotWindow.AnnotationList.ListData:GetItem(tmpIndex)
		-- now add to the multi list
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetParent(annotWindow.AnnotMultiList)
		tmpRow:SetSize(annotWindow.AnnotMultiList:GetWidth(),20)
		tmpRow:SetMultiline(false)
		tmpRow:SetText(tmpItem:GetText())
		tmpRow.Selected=false
		tmpRow.AnnotIndex=tmpItem:GetValue()
		tmpRow.Index=tmpMultiIndex
		tmpMultiIndex=tmpMultiIndex+1
		tmpRow.MouseClick=function(sender,args)
			if sender:IsShiftKeyDown() then
				if annotWindow.AnnotMultiList.ShiftSelectStart==nil then
					annotWindow.AnnotMultiList.ShiftSelectStart=sender.Index
					sender.Selected=true
					sender:SetBackColor(Turbine.UI.Color.Navy)
				else
					local selStart,selEnd
					if annotWindow.AnnotMultiList.ShiftSelectStart>sender.Index then
						selStart=sender.Index
						selEnd=annotWindow.AnnotMultiList.ShiftSelectStart
					else
						selEnd=sender.Index
						selStart=annotWindow.AnnotMultiList.ShiftSelectStart
					end
					for k=selStart,selEnd do
						local tmp=annotWindow.AnnotMultiList:GetItem(k)
						tmp.Selected=true
						tmp:SetBackColor(Turbine.UI.Color.Navy)
					end
				end
			else
				annotWindow.AnnotMultiList.ShiftSelectStart=nil
				sender.Selected=not sender.Selected
				if sender.Selected then
					sender:SetBackColor(Turbine.UI.Color.Navy)
				else
					sender:SetBackColor(Turbine.UI.Color.Black)
				end
			end
			annotWindow.Edit:SetEnabled(annotWindow.AnnotMultiList:GetSelectedCount()==1)
		end
		annotWindow.AnnotMultiList:AddItem(tmpRow)
	end
end
annotWindow.LoadAnnotationList=function()
	local pos1;
	local localAnnotations={};
	annotWindow.AnnotMultiList:ClearItems()
	annotWindow.AnnotationList:ClearList();
	annotWindow.AnnotationList:AddItem(Resource[Settings.language][79],0);
	--annotations[#annotations+1]={1,-12.3,-20.9, 8, 8, 19, "Gramsfoot Map"}; -- Gramsfoot map
	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID and annotations[tmpIndex][5]~=8 and annotations[tmpIndex][6]==nil then
			tmpName=annotations[tmpIndex][7]
			if tmpName==nil or tmpName=="" then
				if annotations[tmpIndex][6]~=nil then
					if mapStrings[Settings.language][annotations[tmpIndex][6]]~=nil then
						tmpName=mapStrings[Settings.language][annotations[tmpIndex][6]]; -- use translated text if found
					elseif mapStrings[1][annotations[tmpIndex][6]]~=nil then
						tmpName=mapStrings[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
					end
				end
			end
			pos1=string.find (tmpName,":",0,true);
			if (pos1~=nil)then
				tmpName=string.sub(tmpName,1,pos1-1);
			end
			localAnnotations[#localAnnotations+1]={tmpName,tmpIndex}
		end
	end
	
	-- now sort the annotations alphabetically
	table.sort(localAnnotations,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);
	for tmpIndex=1,#localAnnotations do
		annotWindow.AnnotationList:AddItem(localAnnotations[tmpIndex][1],localAnnotations[tmpIndex][2]);
	end
	-- force garbage collection of table
	while #localAnnotations>0 do
		table.remove(localAnnotations);
	end
	localAnnotations=nil;
	annotWindow.SynchList()
end
annotWindow.AnnotationList.SelectedIndexChanged = function ()
	annotWindow:EditAnnotation(annotWindow.AnnotationList:GetValue());
end

annotWindow.TypeCaption=Turbine.UI.Label();
annotWindow.TypeCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.TypeCaption:SetPosition(10,annotWindow.AnnotationCaption:GetTop()+annotWindow.AnnotationCaption:GetHeight()+9);
annotWindow.TypeCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.TypeCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.TypeCaption:SetForeColor(Settings.fontColor);
annotWindow.TypeCaption:SetText(Resource[Settings.language][74]..":");
annotWindow.TypeCaption:SetMouseVisible(false);

annotWindow.TypeList=DropDownList();
annotWindow.TypeList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.TypeList:SetPosition(annotWindow.TypeCaption:GetLeft()+annotWindow.TypeCaption:GetWidth()+2,annotWindow.TypeCaption.GetTop()-3);
annotWindow.TypeList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.TypeCaption:GetWidth()+annotWindow.TypeCaption:GetLeft())-30,20);
annotWindow.TypeList:SetTextColor(Settings.listTextColor)
annotWindow.TypeList:SetFont(Turbine.UI.Lotro.Font.Verdana16)
annotWindow.TypeList:SetBorderColor(Settings.trimColor);
annotWindow.TypeList:SetBackColor(Settings.backColor);
annotWindow.TypeList:SetCurrentBackColor(Settings.backColor);
annotWindow.TypeList:SetDropRows(5);

annotWindow.TypeList:AddItem(Resource[Settings.language][110],55);
annotWindow.TypeList:AddItem(Resource[Settings.language][116],11);
annotWindow.TypeList:AddItem(Resource[Settings.language][155],43);
annotWindow.TypeList:AddItem(Resource[Settings.language][156],44);
annotWindow.TypeList:AddItem(Resource[Settings.language][157],45);
annotWindow.TypeList:AddItem(Resource[Settings.language][162],46);
annotWindow.TypeList:AddItem(Resource[Settings.language][182],48);
annotWindow.TypeList:SetSelectedIndex(1);

annotWindow.TypeList.SelectedIndexChanged=function()
	local tmpType=annotWindow.TypeList:GetValue()
	annotWindow.DataCaption:SetVisible(tmpType==43 or tmpType==44 or tmpType==45)
	annotWindow.DataText:SetVisible(false)
	annotWindow.DataTier:SetVisible(tmpType==43 or tmpType==44 or tmpType==45)
	annotWindow.AllegianceList:SetVisible(tmpType==11);
end

annotWindow.NSCoordCaption=Turbine.UI.Label();
annotWindow.NSCoordCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSCoordCaption:SetPosition(10,annotWindow.TypeCaption:GetTop()+annotWindow.TypeCaption:GetHeight()+9);
annotWindow.NSCoordCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.NSCoordCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
annotWindow.NSCoordCaption:SetText(Resource[Settings.language][75]..":");
annotWindow.NSCoordCaption:SetMouseVisible(false);
annotWindow.NSCoordText=Turbine.UI.Lotro.TextBox();
annotWindow.NSCoordText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSCoordText:SetPosition(annotWindow.NSCoordCaption:GetLeft()+annotWindow.NSCoordCaption:GetWidth()+2,annotWindow.NSCoordCaption.GetTop());
annotWindow.NSCoordText:SetSize(60,18);
annotWindow.NSCoordText:SetFont(Turbine.UI.Lotro.Font.Verdana14);

annotWindow.NSButtons=RadioButtonGroup();
annotWindow.NSButtons:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSButtons:SetSize(70,20);
annotWindow.NSButtons:SetPosition(annotWindow.NSCoordText:GetLeft()+annotWindow.NSCoordText:GetWidth()+3,annotWindow.NSCoordText:GetTop()-1);
annotWindow.NSButtons.UnselectedIcon=resourcePath.."RB_unselected.tga";
annotWindow.NSButtons.SelectedIcon=resourcePath.."RB_selected.tga";
annotWindow.NSButtons.IconWidth=16;
annotWindow.NSButtons.IconHeight=16;
annotWindow.NSButtons:SetBorderColor(Settings.backColor);
annotWindow.NSButtons:SetBackColor(Settings.backColor);
annotWindow.NSButtons:SetTextColor(Settings.fontColor);
annotWindow.NSButtons:AddChoice(Resource[Settings.language][150]);
annotWindow.NSButtons:AddChoice(Resource[Settings.language][151]);
annotWindow.NSButtons:SetRows(1);
annotWindow.NSButtons:SetSelectedChoice(2);

annotWindow.EWCoordCaption=Turbine.UI.Label();
annotWindow.EWCoordCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWCoordCaption:SetPosition(10,annotWindow.NSCoordCaption:GetTop()+annotWindow.NSCoordCaption:GetHeight()+9);
annotWindow.EWCoordCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.EWCoordCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
annotWindow.EWCoordCaption:SetText(Resource[Settings.language][76]..":");
annotWindow.EWCoordCaption:SetMouseVisible(false);
annotWindow.EWCoordText=Turbine.UI.Lotro.TextBox();
annotWindow.EWCoordText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWCoordText:SetPosition(annotWindow.EWCoordCaption:GetLeft()+annotWindow.EWCoordCaption:GetWidth()+2,annotWindow.EWCoordCaption.GetTop());
annotWindow.EWCoordText:SetSize(60,18);
annotWindow.EWCoordText:SetFont(Turbine.UI.Lotro.Font.Verdana14);

annotWindow.EWButtons=RadioButtonGroup();
annotWindow.EWButtons:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWButtons:SetSize(70,20);
annotWindow.EWButtons:SetPosition(annotWindow.EWCoordText:GetLeft()+annotWindow.EWCoordText:GetWidth()+3,annotWindow.EWCoordText:GetTop()-1);
annotWindow.EWButtons.UnselectedIcon=resourcePath.."RB_unselected.tga";
annotWindow.EWButtons.SelectedIcon=resourcePath.."RB_selected.tga";
annotWindow.EWButtons.IconWidth=16;
annotWindow.EWButtons.IconHeight=16;
annotWindow.EWButtons:SetBorderColor(Settings.backColor);
annotWindow.EWButtons:SetBackColor(Settings.backColor);
annotWindow.EWButtons:SetTextColor(Settings.fontColor);
annotWindow.EWButtons:AddChoice(Resource[Settings.language][152]);
annotWindow.EWButtons:AddChoice(Resource[Settings.language][153]);
annotWindow.EWButtons:SetRows(1);
annotWindow.EWButtons:SetSelectedChoice(2);

annotWindow.AllegianceCaption=Turbine.UI.Label();
annotWindow.AllegianceCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceCaption:SetPosition(10,annotWindow.EWButtons:GetTop()+annotWindow.EWButtons:GetHeight()+9);
annotWindow.AllegianceCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.AllegianceCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AllegianceCaption:SetForeColor(Settings.fontColor);
annotWindow.AllegianceCaption:SetText(Resource[Settings.language][67]..":");
annotWindow.AllegianceCaption:SetMouseVisible(false);

annotWindow.AllegianceNA=Turbine.UI.Label();
annotWindow.AllegianceNA:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceNA:SetPosition(annotWindow.AllegianceCaption:GetLeft()+annotWindow.AllegianceCaption:GetWidth()+2,annotWindow.AllegianceCaption.GetTop()-3);
annotWindow.AllegianceNA:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AllegianceCaption:GetWidth()+annotWindow.AllegianceCaption:GetLeft())-30,20);
annotWindow.AllegianceNA:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AllegianceNA:SetBackColor(Settings.backColor);
annotWindow.AllegianceNA:SetForeColor(Settings.fontColor);
annotWindow.AllegianceNA:SetText(Resource[Settings.language][199]);

annotWindow.AllegianceList=DropDownList();
annotWindow.AllegianceList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceList:SetPosition(annotWindow.AllegianceCaption:GetLeft()+annotWindow.AllegianceCaption:GetWidth()+2,annotWindow.AllegianceCaption.GetTop()-3);
annotWindow.AllegianceList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AllegianceCaption:GetWidth()+annotWindow.AllegianceCaption:GetLeft())-30,20);
annotWindow.AllegianceList:SetBorderColor(Settings.trimColor);
annotWindow.AllegianceList:SetTextColor(Settings.listTextColor)
annotWindow.AllegianceList:SetBackColor(Settings.backColor);
annotWindow.AllegianceList:SetCurrentBackColor(Settings.backColor);
annotWindow.AllegianceList:SetDropRows(5);

annotWindow.AllegianceList:AddItem(Resource[Settings.language][198],1); -- none
annotWindow.AllegianceList:AddItem(Resource[Settings.language][68],2); -- creep
annotWindow.AllegianceList:AddItem(Resource[Settings.language][69],3); -- freep
annotWindow.AllegianceList:AddItem(Resource[Settings.language][70],4); -- delving
annotWindow.AllegianceList:SetSelectedIndex(1);
annotWindow.AllegianceList:SetVisible(false);

annotWindow.DataCaption=Turbine.UI.Label();
annotWindow.DataCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DataCaption:SetPosition(10,annotWindow.AllegianceList:GetTop()+annotWindow.AllegianceList:GetHeight()+9);
annotWindow.DataCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.DataCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DataCaption:SetForeColor(Settings.fontColor);
annotWindow.DataCaption:SetText("");
annotWindow.DataCaption:SetMouseVisible(false);
annotWindow.DataCaption:SetVisible(false)

annotWindow.DataText=Turbine.UI.Lotro.TextBox();
annotWindow.DataText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DataText:SetPosition(annotWindow.DataCaption:GetLeft()+annotWindow.DataCaption:GetWidth()+2,annotWindow.DataCaption.GetTop());
annotWindow.DataText:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.DataCaption:GetWidth()+annotWindow.DataCaption:GetLeft())-30,18);
annotWindow.DataText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DataText:SetMultiline(false);
annotWindow.DataText:SetVisible(false)

annotWindow.DataTier=DropDownList();
annotWindow.DataTier:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DataTier:SetPosition(annotWindow.DataCaption:GetLeft()+annotWindow.DataCaption:GetWidth()+2,annotWindow.DataCaption.GetTop()-3);
annotWindow.DataTier:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.DataCaption:GetWidth()+annotWindow.DataCaption:GetLeft())-30,20);
annotWindow.DataTier:SetBorderColor(Settings.trimColor);
annotWindow.DataTier:SetTextColor(Settings.listTextColor)
annotWindow.DataTier:SetBackColor(Settings.backColor);
annotWindow.DataTier:SetCurrentBackColor(Settings.backColor);
annotWindow.DataTier:SetDropRows(5);
annotWindow.DataTier:SetVisible(false)

for k,v in ipairs(craftTier) do
	annotWindow.DataTier:AddItem(v[Settings.language],k)
end


annotWindow.NameCaption=Turbine.UI.Label();
annotWindow.NameCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NameCaption:SetPosition(10,annotWindow.DataCaption:GetTop()+annotWindow.DataCaption:GetHeight()+9);
annotWindow.NameCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.NameCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NameCaption:SetForeColor(Settings.fontColor);
annotWindow.NameCaption:SetText(Resource[Settings.language][77]..":");
annotWindow.NameCaption:SetMouseVisible(false);
annotWindow.NameText=Turbine.UI.Lotro.TextBox();
annotWindow.NameText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NameText:SetPosition(annotWindow.NameCaption:GetLeft()+annotWindow.NameCaption:GetWidth()+2,annotWindow.NameCaption.GetTop());
annotWindow.NameText:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.NameCaption:GetWidth()+annotWindow.NameCaption:GetLeft())-30,18);
annotWindow.NameText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NameText:SetMultiline(false);

annotWindow.DescriptionCaption=Turbine.UI.Label();
annotWindow.DescriptionCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DescriptionCaption:SetPosition(10,annotWindow.NameCaption:GetTop()+annotWindow.NameCaption:GetHeight()+9);
annotWindow.DescriptionCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.DescriptionCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
annotWindow.DescriptionCaption:SetText(Resource[Settings.language][78]..":");
annotWindow.DescriptionCaption:SetMouseVisible(false);
annotWindow.DescriptionText=Turbine.UI.Lotro.TextBox();
annotWindow.DescriptionText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DescriptionText:SetPosition(annotWindow.DescriptionCaption:GetLeft()+annotWindow.DescriptionCaption:GetWidth()+2,annotWindow.DescriptionCaption.GetTop());
annotWindow.DescriptionText:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.DescriptionCaption:GetWidth()+annotWindow.DescriptionCaption:GetLeft())-30,72);
annotWindow.DescriptionText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DescriptionText:SetMultiline(true);

--** SAVE AND CANCEL
annotWindow.SaveButton=Turbine.UI.Lotro.Button();
annotWindow.SaveButton:SetParent(annotWindow.AnnotationsPanel);
annotWindow.SaveButton:SetSize(120,20);
annotWindow.SaveButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.SaveButton:SetPosition((annotWindow:GetWidth()-annotWindow.SaveButton:GetWidth()*3)/4,annotWindow.AnnotationsPanel:GetHeight()-20);
annotWindow.SaveButton:SetText(Resource[Settings.language][11]);
annotWindow.SaveButton.Update=function()
	-- used to wait for MMCust to complete and then kill it
	if Turbine.Shell.IsCommand("0MMCC") then
		Turbine.PluginManager.UnloadScriptState("MMCust")
		annotWindow.SaveButton:SetWantsUpdates(false)
		for k,v in ipairs(annotWindow.cmdList) do
			Turbine.Shell.RemoveCommand(v); -- remove prior cmd
		end
		annotWindow.cmdList={}
		-- if TerrainMap is running, we need to trigger a refresh
		Turbine.Shell.WriteLine("Custom Annotations Saved.") -- terrain map refresh will be triggered by this, plus it gives seemingly useful user feedback ;)
	end
	-- refresh the 'old' values for selected annotation
	annotWindow:EditAnnotation(annotWindow.AnnotationList:GetValue());
end
annotWindow.SaveButton.Click=function()
	local hasError=false;
	-- validate option values
	-- verify that the coordinates land on the current map
	local X=tonumber(annotWindow.EWCoordText:GetText());
	if X<0 then X=0-X end -- we account for negatives with the buttons
	if annotWindow.EWButtons:GetSelectedChoice()==2 then X=0-X end
	X=math.floor(X*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
	local Y=tonumber(annotWindow.NSCoordText:GetText())
	if Y<0 then Y=0-Y end
	if annotWindow.NSButtons:GetSelectedChoice()==2 then Y=0-Y end
	Y=math.floor(Y*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
	if X<1 or X>mapInfo[mapWindow.CurrentMapID][4] then
		hasError=true;
		annotWindow.EWCoordCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	if Y<1 or Y>mapInfo[mapWindow.CurrentMapID][5] then
		hasError=true;
		annotWindow.NSCoordCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	annotWindow.NameText:SetText(string.ltrim(annotWindow.NameText:GetText()));
	annotWindow.DescriptionText:SetText(string.ltrim(annotWindow.DescriptionText:GetText()));
	if annotWindow.NameText:GetText()=="" or string.find(annotWindow.NameText:GetText(),":",nil,true)~=nil then
		hasError=true;
		annotWindow.NameCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	if annotWindow.DescriptionText:GetText()=="" or string.find(annotWindow.DescriptionText:GetText(),":",nil,true)~=nil then
		hasError=true;
		annotWindow.DescriptionCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end

-- verify that name is non-blank and contains no ":"
-- verify that description is non-blank

	if hasError then
		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][80]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);
	else
		local tmpAnnotationIndex;
		if annotWindow.AnnotationList:GetValue()==0 then
			-- if creating a new annotation, we need to figure out where to put it in the alphabetical list
			tmpAnnotationIndex=#annotations+1;
			annotations[tmpAnnotationIndex]={};
			annotations[tmpAnnotationIndex][1]=mapWindow.CurrentMapID;
			if annotWindow.NSButtons:GetSelectedChoice()==1 then
				annotations[tmpAnnotationIndex][2]=tonumber(annotWindow.NSCoordText:GetText());
			else
				annotations[tmpAnnotationIndex][2]=0-tonumber(annotWindow.NSCoordText:GetText());
			end
			if annotWindow.EWButtons:GetSelectedChoice()==1 then
				annotations[tmpAnnotationIndex][3]=tonumber(annotWindow.EWCoordText:GetText());
			else
				annotations[tmpAnnotationIndex][3]=0-tonumber(annotWindow.EWCoordText:GetText());
			end
			annotations[tmpAnnotationIndex][4]=annotWindow.TypeList:GetValue();
			if annotWindow.AllegianceList:IsVisible() then
				annotations[tmpAnnotationIndex][5]=annotWindow.AllegianceList:GetValue();
			else
				annotations[tmpAnnotationIndex][5]=1;
			end
			annotations[tmpAnnotationIndex][6]=nil;
			annotations[tmpAnnotationIndex][7]=annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText());
			annotations[tmpAnnotationIndex][8]=0;
			if annotWindow.DataTier:IsVisible() then
				annotations[tmpAnnotationIndex][8]=annotWindow.DataTier:GetValue();
			end
			if annotWindow.DataText:IsVisible() then
				annotations[tmpAnnotationIndex][8]=tonumber(annotWindow.DataText:GetText());
			end
			annotations[tmpAnnotationIndex][9]=0;
			annotations[tmpAnnotationIndex][10]=0;
			annotations[tmpAnnotationIndex][11]=0;
			annotWindow.LoadAnnotationList(); --note, tmpAnnotationIndex will no longer be valid after this operation
			local tmpValue;
			for tmpIndex=2,annotWindow.AnnotationList.ListData:GetItemCount() do
				tmpValue=annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue();
				if annotations[annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue()][7]==annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText()) then
					annotWindow.AnnotationList:SetSelectedIndex(tmpIndex);
					annotWindow:EditAnnotation(tmpValue);
					break;
				end
			end
			-- need to create a 0MMCD_r_row_col_S_data command entry and load MMCust to export the new annot to TerrainMap
			local cmdStr
			if Settings.TerrainMapCompatability then
				cmdStr="0MMCD_S_"..tostring(annotWindow.region).."_"..tostring(annotations[tmpAnnotationIndex][2]).."_"..tostring(annotations[tmpAnnotationIndex][3]).."_"..tostring(annotations[tmpAnnotationIndex][4]).."|"..tostring(annotations[tmpAnnotationIndex][8]).."_"..tostring(annotations[tmpAnnotationIndex][5]).."_"..string.encode(annotWindow.NameText:GetText()).."_"..string.encode(annotWindow.DescriptionText:GetText())
			else
				cmdStr="0MMCD_SM_"..tostring(annotWindow.region).."_"..tostring(annotations[tmpAnnotationIndex][2]).."_"..tostring(annotations[tmpAnnotationIndex][3]).."_"..tostring(annotations[tmpAnnotationIndex][4]).."|"..tostring(annotations[tmpAnnotationIndex][8]).."_"..tostring(annotations[tmpAnnotationIndex][5]).."_"..string.encode(annotWindow.NameText:GetText()).."_"..string.encode(annotWindow.DescriptionText:GetText())
			end
			local tmpCmd=Turbine.ShellCommand()
			Turbine.Shell.AddCommand(cmdStr,tmpCmd)
			table.insert(annotWindow.cmdList,tmpCmd)
			if debug then
				Turbine.Shell.WriteLine("annotWindowCmd:"..cmdStr)
				tmpCmd=Turbine.ShellCommand() -- get a new command object so we don't accidentally stomp on the old one, the old one is safely preserved in the cmdList
				Turbine.Shell.AddCommand("MMDebug",tmpCmd)
				table.insert(annotWindow.cmdList,tmpCmd)
			end
			annotWindow.SaveButton:SetWantsUpdates(true)
			Turbine.PluginManager.LoadPlugin("MMCust")
		else
			-- if modifying an existing annotation, only update the Coords and type if it is not a "default"
			tmpAnnotationIndex=annotWindow.AnnotationList:GetValue();
			-- update the datavalue if it is visible
			if annotWindow.DataTier:IsVisible() then
				annotations[tmpAnnotationIndex][8]=annotWindow.DataTier:GetValue();
			end
			if annotWindow.DataText:IsVisible() then
				annotations[tmpAnnotationIndex][8]=tonumber(annotWindow.DataText:GetText());
			end
			if annotations[tmpAnnotationIndex][6]==nil then
				if annotWindow.NSButtons:GetSelectedChoice()==1 then
					annotations[tmpAnnotationIndex][2]=tonumber(annotWindow.NSCoordText:GetText());
				else
					annotations[tmpAnnotationIndex][2]=0-tonumber(annotWindow.NSCoordText:GetText());
				end
				if annotWindow.EWButtons:GetSelectedChoice()==1 then
					annotations[tmpAnnotationIndex][3]=tonumber(annotWindow.EWCoordText:GetText());
				else
					annotations[tmpAnnotationIndex][3]=0-tonumber(annotWindow.EWCoordText:GetText());
				end
				annotations[tmpAnnotationIndex][4]=annotWindow.TypeList:GetValue();
				if annotWindow.AllegianceList:IsVisible() then
					annotations[tmpAnnotationIndex][5]=annotWindow.AllegianceList:GetValue();
				else
					annotations[tmpAnnotationIndex][5]=1;
				end
			end
			-- -- we have no way of auto-translating, so that is the best we can do
			-- only update the name and description even if the type or coords were somehow enabled
			annotations[tmpAnnotationIndex][7]=annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText());
			annotWindow.AnnotationList.ListData:GetItem(annotWindow.AnnotationList.ListData:GetSelectedIndex()):SetText(annotWindow.NameText:GetText());
			annotWindow.AnnotationList.CurrentValue:SetText(annotWindow.NameText:GetText());

			local oldCmdStr=tostring(annotWindow.region).."_"..tostring(annotWindow.origNS).."_"..tostring(annotWindow.origEW).."_"..tostring(annotWindow.origType).."|"..tostring( annotWindow.origData).."_"..tostring(annotWindow.origAllegiance).."_"..string.encode(annotWindow.origName).."_"..string.encode(annotWindow.origDesc)
			local newCmdStr=tostring(annotWindow.region).."_"..tostring(annotations[tmpAnnotationIndex][2]).."_"..tostring(annotations[tmpAnnotationIndex][3]).."_"..tostring(annotations[tmpAnnotationIndex][4]).."|"..tostring(annotations[tmpAnnotationIndex][8]).."_"..tostring(annotations[tmpAnnotationIndex][5]).."_"..string.encode(annotWindow.NameText:GetText()).."_"..string.encode(annotWindow.DescriptionText:GetText())
			if oldCmdStr~=newCmdStr then
				-- only save if the new is not identical to the old
				local oldCmd=Turbine.ShellCommand()
				if Settings.TerrainMapCompatability then
					Turbine.Shell.AddCommand("0MMCD_D_"..oldCmdStr,oldCmd)
				else
					Turbine.Shell.AddCommand("0MMCD_DM_"..oldCmdStr,oldCmd)
				end
				table.insert(annotWindow.cmdList,oldCmd)
				local newCmd=Turbine.ShellCommand()
				if Settings.TerrainMapCompatability then
					Turbine.Shell.AddCommand("0MMCD_S_"..newCmdStr,newCmd)
				else
					Turbine.Shell.AddCommand("0MMCD_SM_"..newCmdStr,newCmd)
				end
				table.insert(annotWindow.cmdList,newCmd)
				if debug then
					Turbine.Shell.WriteLine("oldAnnotWindowCmd:"..oldCmdStr)
					Turbine.Shell.WriteLine("newAnnotWindowCmd:"..newCmdStr)
					tmpCmd=Turbine.ShellCommand() -- get a new command object so we don't accidentally stomp on the old one, the old one is safely preserved in the cmdList
					Turbine.Shell.AddCommand("MMDebug",tmpCmd)
					table.insert(annotWindow.cmdList,tmpCmd)
				end
				annotWindow.SaveButton:SetWantsUpdates(true)
				Turbine.PluginManager.LoadPlugin("MMCust")
			end
		end
		annotWindow.SynchList()

		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][81]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);

		mapWindow.NeedsRefresh=true;
		mapWindow:SetWantsUpdates(true);
	end
end

annotWindow.ReloadButton=Turbine.UI.Lotro.Button();
annotWindow.ReloadButton:SetParent(annotWindow.AnnotationsPanel);
annotWindow.ReloadButton:SetSize(annotWindow.SaveButton:GetWidth(),20);
annotWindow.ReloadButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.ReloadButton:SetPosition(annotWindow.SaveButton:GetLeft()+annotWindow.SaveButton:GetWidth()+(annotWindow:GetWidth()-annotWindow.ReloadButton:GetWidth()*3)/4,annotWindow.SaveButton:GetTop());
annotWindow.ReloadButton:SetText(Resource[Settings.language][64]);
annotWindow.ReloadButton.Click=function()
	annotWindow:SetWantsUpdates(true);
	iconInfo=nil -- clear the icon info so it reloads
	mapInfo=nil -- clear the map info so it reloads
	AddDefaultOverlays();
	RefreshMap(0); -- this will reload the current map, but force a reload of the annotations
end

annotWindow.DeleteButton=Turbine.UI.Lotro.Button();
annotWindow.DeleteButton:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DeleteButton:SetSize(annotWindow.SaveButton:GetWidth(),20);
annotWindow.DeleteButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.DeleteButton:SetPosition(annotWindow.ReloadButton:GetLeft()+annotWindow.ReloadButton:GetWidth()+(annotWindow:GetWidth()-annotWindow.DeleteButton:GetWidth()*3)/4,annotWindow.SaveButton:GetTop());
annotWindow.DeleteButton:SetText(Resource[Settings.language][84]);
annotWindow.DeleteButton.Click=function()
	-- users can delete anything that shows up in the list since the list doesn't have map points :)
	if annotWindow.AnnotationList:GetValue()>0 then
		local oldCmdStr=tostring(annotWindow.region).."_"..tostring(annotWindow.origNS).."_"..tostring(annotWindow.origEW).."_"..tostring(annotWindow.origType).."_"..tostring(annotWindow.origAllegiance).."_"..string.encode(annotWindow.origName).."_"..string.encode(annotWindow.origDesc)
		local oldCmd=Turbine.ShellCommand()
		if Settings.TerrainMapCompatability then
			Turbine.Shell.AddCommand("0MMCD_D_"..oldCmdStr,oldCmd)
		else
			Turbine.Shell.AddCommand("0MMCD_DM_"..oldCmdStr,oldCmd)
		end
		table.insert(annotWindow.cmdList,oldCmd)
		if debug then
			Turbine.Shell.WriteLine("annotWindowCmd:"..oldCmdStr)
			tmpCmd=Turbine.ShellCommand() -- get a new command object so we don't accidentally stomp on the old one, the old one is safely preserved in the cmdList
			Turbine.Shell.AddCommand("MMDebug",tmpCmd)
			table.insert(annotWindow.cmdList,tmpCmd)
		end
		annotWindow.SaveButton:SetWantsUpdates(true)
		Turbine.PluginManager.LoadPlugin("MMCust")
		table.remove(annotations,annotWindow.AnnotationList:GetValue());
		annotWindow.LoadAnnotationList(); --note, tmpAnnotationIndex will no longer be valid after this operation
		-- now point to the "New" entry
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][85]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);
		annotWindow.SynchList()

		mapWindow.NeedsRefresh=true;
		mapWindow:SetWantsUpdates(true);
	end
end

annotWindow.ErrorLabel=Turbine.UI.Label();
annotWindow.ErrorLabel:SetParent(annotWindow);
annotWindow.ErrorLabel:SetText("")
annotWindow.ErrorLabel:SetSize(annotWindow:GetWidth()-30,18);
annotWindow.ErrorLabel:SetPosition((annotWindow:GetWidth()-annotWindow.ErrorLabel:GetWidth())/2,annotWindow.SaveButton:GetTop()-annotWindow.ErrorLabel:GetHeight()-5);
annotWindow.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18);
annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
annotWindow.ErrorLabel:SetVisible(false);
annotWindow.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
annotWindow.ErrorLabel:SetMouseVisible(false);

annotWindow.ListPanel=Turbine.UI.Control()
annotWindow.ListPanel:SetParent(annotWindow)
annotWindow.ListPanel:SetSize(annotWindow.AnnotationsPanel:GetSize())
annotWindow.ListPanel:SetPosition(annotWindow.AnnotationsPanel:GetPosition())
annotWindow.ListPanel:SetVisible(false)

--*** add multiselect list, scrollbar, edit and delete buttons, select all? select clear?
annotWindow.AnnotMultiList=Turbine.UI.ListBox()
annotWindow.AnnotMultiList:SetParent(annotWindow.ListPanel)
annotWindow.AnnotMultiList:SetSize(annotWindow.ListPanel:GetWidth()-130,annotWindow.ListPanel:GetHeight())
-- note, listboxes do not support multi-select so we have to provide that functionality

annotWindow.MultiVScroll=Turbine.UI.Lotro.ScrollBar()
annotWindow.MultiVScroll:SetParent(annotWindow.ListPanel)
annotWindow.MultiVScroll:SetSize(10,annotWindow.AnnotMultiList:GetHeight());
annotWindow.MultiVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
annotWindow.MultiVScroll:SetPosition(annotWindow.AnnotMultiList:GetWidth(),0);
annotWindow.AnnotMultiList:SetVerticalScrollBar(annotWindow.MultiVScroll)

annotWindow.SelAll=Turbine.UI.Lotro.Button()
annotWindow.SelAll:SetParent(annotWindow.ListPanel)
annotWindow.SelAll:SetSize(annotWindow.ListPanel:GetWidth()-annotWindow.MultiVScroll:GetLeft()-annotWindow.MultiVScroll:GetWidth()-10,20)
annotWindow.SelAll:SetPosition(annotWindow.MultiVScroll:GetLeft()+annotWindow.MultiVScroll:GetWidth()+5,annotWindow.ListPanel:GetHeight()/2-25)
annotWindow.SelAll:SetText(Resource[Settings.language][348])
annotWindow.SelAll.Click=function()
	for k=1,annotWindow.AnnotMultiList:GetItemCount() do
		local tmpRow=annotWindow.AnnotMultiList:GetItem(k)
		tmpRow.Selected=true
		tmpRow:SetBackColor(Turbine.UI.Color.Navy)
	end
	annotWindow.Edit:SetEnabled(annotWindow.AnnotMultiList:GetSelectedCount()==1)
end
annotWindow.AnnotMultiList.GetSelectedCount=function()
	local count=0
	for k=1,annotWindow.AnnotMultiList:GetItemCount() do
		if annotWindow.AnnotMultiList:GetItem(k).Selected==true then count=count+1 end
	end
	return count
end
annotWindow.ClearAll=Turbine.UI.Lotro.Button()
annotWindow.ClearAll:SetParent(annotWindow.ListPanel)
annotWindow.ClearAll:SetSize(annotWindow.SelAll:GetSize())
annotWindow.ClearAll:SetPosition(annotWindow.SelAll:GetLeft(),annotWindow.ListPanel:GetHeight()/2+5)
annotWindow.ClearAll:SetText(Resource[Settings.language][349])
annotWindow.ClearAll.Click=function()
	for k=1,annotWindow.AnnotMultiList:GetItemCount() do
		local tmpRow=annotWindow.AnnotMultiList:GetItem(k)
		tmpRow.Selected=false
		tmpRow:SetBackColor(Turbine.UI.Color.Black)
	end
	annotWindow.Edit:SetEnabled(false)
end
annotWindow.Edit=Turbine.UI.Lotro.Button()
annotWindow.Edit:SetParent(annotWindow.ListPanel)
annotWindow.Edit:SetSize(annotWindow.SelAll:GetSize())
annotWindow.Edit:SetPosition(annotWindow.SelAll:GetLeft(),5)
annotWindow.Edit:SetText(Resource[Settings.language][83])
annotWindow.Edit:SetEnabled(false)
annotWindow.Edit.Click=function()
	local index
	for k=1,annotWindow.AnnotMultiList:GetItemCount() do
		local tmpRow=annotWindow.AnnotMultiList:GetItem(k)
		if tmpRow.Selected then
			index=tmpRow.AnnotIndex
			break
		end
	end
	if index~=nil then
		annotWindow:SelectAnnotation(index)
	end
end

annotWindow.Delete=Turbine.UI.Lotro.Button()
annotWindow.Delete:SetParent(annotWindow.ListPanel)
annotWindow.Delete:SetSize(annotWindow.SelAll:GetSize())
annotWindow.Delete:SetPosition(annotWindow.SelAll:GetLeft(),annotWindow.ListPanel:GetHeight()-25)
annotWindow.Delete:SetText(Resource[Settings.language][84])
annotWindow.Delete.Click=function()
-- need to loop through list and for any selected create 0MMCD_D_ or 0MMCD_DM_ commands, then call MMCust plugin
	-- users can delete anything that shows up in the list since the list doesn't have map points :)
	local delOK=false
	local delIndexes={}
	for listIndex=1,annotWindow.AnnotMultiList:GetItemCount() do
		local tmpRow=annotWindow.AnnotMultiList:GetItem(listIndex)
		if tmpRow.Selected then
			local tmpIndex=tmpRow.AnnotIndex
			tmpName,tmpDescription=annotWindow.GetAnnotNameDesc(tmpIndex)
			local oldCmdStr=tostring(annotWindow.region).."_"..tostring(annotations[tmpIndex][2]).."_"..tostring(annotations[tmpIndex][3]).."_"..tostring(annotations[tmpIndex][4]).."_"..tostring(annotations[tmpIndex][5]).."_"..string.encode(tmpName).."_"..string.encode(tmpDescription)
			local oldCmd=Turbine.ShellCommand()
			if Settings.TerrainMapCompatability then
				Turbine.Shell.AddCommand("0MMCD_D_"..oldCmdStr,oldCmd)
			else
				Turbine.Shell.AddCommand("0MMCD_DM_"..oldCmdStr,oldCmd)
			end
			table.insert(annotWindow.cmdList,oldCmd)
			-- if we remove the annotation now, the indexes in annotWindow.AnnotMultiList will all be off
			table.insert(delIndexes,tmpIndex)
			delOK=true
		end
	end
	if delOK then
		-- remove the entries in inverse index order so the removed rows won't affect the indexes
		table.sort(delIndexes, function(a,b) return a>b end)
		for k,v in ipairs(delIndexes) do
			table.remove(annotations,v)
		end

		annotWindow.SaveButton:SetWantsUpdates(true)
		Turbine.PluginManager.LoadPlugin("MMCust")
		annotWindow.LoadAnnotationList();
		-- now point to the "New" entry
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][85]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);
		annotWindow.SynchList()
		mapWindow.NeedsRefresh=true;
		mapWindow:SetWantsUpdates(true);
	end
end

annotWindow.ListPanel.MouseClick=function()
	annotWindow.ListPanel:SetVisible(false)
	annotWindow.AnnotationsPanel:SetVisible(true)
end

annotWindow.VisibleChanged=function(sender,args)
	if annotWindow:IsVisible() then
		-- refresh the options status to reflect current values
		annotWindow:SetLanguage(Settings.language);
	end
end
annotWindow.Update=function(sender,args)
	if annotWindow.HadErrors then
		if Turbine.Engine:GetGameTime()>annotWindow.ErrorFadeTime then
			annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
			annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
			annotWindow.NameCaption:SetForeColor(Settings.fontColor);
			annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
			annotWindow:SetWantsUpdates(false);
			annotWindow.ErrorLabel:SetVisible(false);
			annotWindow.HadErrors=false
		end
	end
end

annotWindow.NSCoordText:SetZOrder(5);
annotWindow.EWCoordText:SetZOrder(5);
annotWindow.NameText:SetZOrder(5);
annotWindow.DescriptionText:SetZOrder(5);
annotWindow.DataTier:SetZOrder(10);
annotWindow.AllegianceList:SetZOrder(15);
annotWindow.TypeList:SetZOrder(20);
annotWindow.AnnotationList:SetZOrder(25);

annotWindow.SelectAnnotation=function(sender,annotationIndex)
	for tmpIndex=1,annotWindow.AnnotationList.ListData:GetItemCount() do
		if annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue()==annotationIndex then
			annotWindow.AnnotationList:SetSelectedIndex(tmpIndex);
			annotWindow:EditAnnotation(annotationIndex);
			break
		end
	end
end
annotWindow.GetAnnotNameDesc=function(annotationIndex)
	local tmpName=annotations[annotationIndex][7]
	local tmpDescription=""
	if tmpName==nil or tmpName=="" then
		if annotations[annotationIndex][6]~=nil then
			if mapStrings[Settings.language][annotations[annotationIndex][6]]~=nil then
				tmpName=mapStrings[Settings.language][annotations[annotationIndex][6]]; -- use translated text if found
			elseif mapStrings[1][annotations[annotationIndex][6]]~=nil then
				tmpName=mapStrings[1][annotations[annotationIndex][6]]; -- fall back to english if translated text not found
			end
		end
	end
	local pos1=string.find (tmpName,":",0,true);
	if (pos1~=nil)then
		tmpDescription=string.ltrim(string.sub(tmpName,pos1+1));
		tmpName=string.sub(tmpName,1,pos1-1);
	end

	return tmpName,tmpDescription
end
annotWindow.EditAnnotation=function(sender,annotationIndex)
	annotWindow.ListPanel:SetVisible(false)
	annotWindow.AnnotationsPanel:SetVisible(true)
	local tmpName,tmpDescription
	annotWindow.AnnotationIndex=annotationIndex;

-- all annotations have the form:{MapID, N/S, E/W, IconID, Allegiance, TextID, Description, NPCRank/MapID/Tier, NPC Type, QuestType, SpecialLoot}
	annotWindow.TypeList:HideList();
	local tmpType=annotWindow.TypeList:GetValue()
	annotWindow.DataCaption:SetVisible(tmpType==43 or tmpType==44 or tmpType==45)
	annotWindow.DataText:SetVisible(false)
	annotWindow.DataTier:SetVisible(tmpType==43 or tmpType==44 or tmpType==45)
	if annotationIndex==nil or annotationIndex<1 then
		annotWindow.TypeList:SetEnabled(true);
		annotWindow.NSCoordText:SetEnabled(true);
		annotWindow.EWCoordText:SetEnabled(true);
		annotWindow.NameText:SetEnabled(true);
		annotWindow.DescriptionText:SetEnabled(true);
		annotWindow.AllegianceList:SetEnabled(true);
		annotWindow.DataTier:SetEnabled(true);
		annotWindow.origNS=nil
		annotWindow.origEW=nil
		annotWindow.origType=nil
		annotWindow.origData=nil
		annotWindow.origAllegiance=nil
		annotWindow.origName=nil
		annotWindow.origDesc=nil
	else
		tmpName,tmpDescription=annotWindow.GetAnnotNameDesc(annotationIndex)
		for tmpIndex=1,annotWindow.TypeList.ListData:GetItemCount() do
			if annotWindow.TypeList.ListData:GetItem(tmpIndex):GetValue()==annotations[annotationIndex][4] then
				annotWindow.TypeList:SetSelectedIndex(tmpIndex);
				break;
			end
		end

		annotWindow.origNS=annotations[annotationIndex][2]
		annotWindow.origEW=annotations[annotationIndex][3]
		annotWindow.origType=annotations[annotationIndex][4]
		annotWindow.origData=annotations[annotationIndex][8]
		annotWindow.origAllegiance=annotations[annotationIndex][5]
		annotWindow.origName=tmpName
		annotWindow.origDesc=tmpDescription

		local NSCoord=annotations[annotationIndex][2];
		local EWCoord=annotations[annotationIndex][3];
		if EWCoord<0 then
			annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(2)
		else
			annotWindow.EWCoordText:SetText(tostring(EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(1)
		end
		if NSCoord<0 then
			annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(2)
		else
			annotWindow.NSCoordText:SetText(tostring(NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(1)
		end

		local allegiance=annotations[annotationIndex][5];
		if allegiance==nil or allegiance<1 then allegiance=1 end
		annotWindow.AllegianceList:SetSelectedIndex(allegiance);
		annotWindow.AllegianceList:SetVisible(annotWindow.TypeList:GetValue()==11);

		annotWindow.NameText:SetText(tmpName);
		annotWindow.DescriptionText:SetText(tmpDescription);
		if annotations[annotationIndex][6]==nil then
			annotWindow.TypeList:SetEnabled(true);
			annotWindow.NSCoordText:SetEnabled(true);
			annotWindow.EWCoordText:SetEnabled(true);
			annotWindow.NameText:SetEnabled(true);
			annotWindow.DescriptionText:SetEnabled(true);
			annotWindow.AllegianceList:SetEnabled(true);
		else
			annotWindow.TypeList:SetEnabled(false);
			annotWindow.NSCoordText:SetEnabled(false);
			annotWindow.EWCoordText:SetEnabled(false);
			annotWindow.NameText:SetEnabled(true);
			annotWindow.DescriptionText:SetEnabled(true);
			annotWindow.AllegianceList:SetEnabled(false);
		end
		-- display the data caption and data
		annotWindow.DataText:SetText(tostring(annotations[annotationIndex][8]))
		annotWindow.DataTier:SetSelectedIndex(annotations[annotationIndex][8])
		if ((annotations[annotationIndex][4]==43)or(annotations[annotationIndex][4]==44)or(annotations[annotationIndex][4]==45)) then
			-- set dataCaption to "Tier"
			annotWindow.DataCaption:SetText(Resource[Settings.language][159])
			annotWindow.DataCaption:SetVisible(true)
			annotWindow.DataText:SetVisible(false)
			annotWindow.DataTier:SetVisible(true)
		end
	end
end

annotWindow.SetTrimColor=function()
	annotWindow.AnnotationList:SetBorderColor(Settings.trimColor);
	annotWindow.TypeList:SetBorderColor(Settings.trimColor);
	annotWindow.AllegianceList:SetBorderColor(Settings.trimColor);
	annotWindow.DataTier:SetBorderColor(Settings.trimColor);
end
annotWindow.SetBackColor=function()
	annotWindow.AnnotationsPanel:SetBackColor(Settings.backColor);
	annotWindow.AnnotationList:SetBackColor(Settings.backColor);
	annotWindow.AnnotationList:SetCurrentBackColor(Settings.backColor);
	annotWindow.TypeList:SetBackColor(Settings.backColor);
	annotWindow.TypeList:SetCurrentBackColor(Settings.backColor);
	annotWindow.NSButtons:SetBorderColor(Settings.backColor);
	annotWindow.NSButtons:SetBackColor(Settings.backColor);
	annotWindow.EWButtons:SetBorderColor(Settings.backColor);
	annotWindow.EWButtons:SetBackColor(Settings.backColor);
	annotWindow.AllegianceNA:SetBackColor(Settings.backColor);
	annotWindow.AllegianceList:SetBackColor(Settings.backColor);
	annotWindow.AllegianceList:SetCurrentBackColor(Settings.backColor);
	annotWindow.DataTier:SetBackColor(Settings.backColor);
	annotWindow.DataTier:SetCurrentBackColor(Settings.backColor);
end
annotWindow.SetFontColor=function()
	annotWindow.AnnotationCaption:SetForeColor(Settings.fontColor);
	annotWindow.TypeCaption:SetForeColor(Settings.fontColor);
	annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
	annotWindow.NSButtons:SetTextColor(Settings.fontColor);
	annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
	annotWindow.EWButtons:SetTextColor(Settings.fontColor);
	annotWindow.NameCaption:SetForeColor(Settings.fontColor);
	annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
	annotWindow.AllegianceCaption:SetForeColor(Settings.fontColor);
	annotWindow.AllegianceNA:SetForeColor(Settings.fontColor);
	annotWindow.DataCaption:SetForeColor(Settings.fontColor);
end
annotWindow.SetHeadingsColor=function()
end
annotWindow.SetListTextColor=function()
	annotWindow.AnnotationList:SetTextColor(Settings.listTextColor)
	annotWindow.TypeList:SetTextColor(Settings.listTextColor)
	annotWindow.AllegianceList:SetTextColor(Settings.listTextColor)
	annotWindow.DataTier:SetTextColor(Settings.listTextColor)
end

annotWindow.SetLanguage=function()
	annotWindow:SetText(Resource[Settings.language][72]);
	annotWindow.AnnotationCaption:SetText(Resource[Settings.language][73]..":");
	annotWindow.AnnotationList.ListData:GetItem(1):SetText(Resource[Settings.language][79]);
	annotWindow.SaveButton:SetText(Resource[Settings.language][11]);
	annotWindow.ReloadButton:SetText(Resource[Settings.language][64]);
	annotWindow.TypeCaption:SetText(Resource[Settings.language][74]..":");
	annotWindow.DataCaption:SetText(Resource[Settings.language][159]..":");

	annotWindow.TypeList.ListData:GetItem(1):SetText(Resource[Settings.language][110]);
	annotWindow.TypeList.ListData:GetItem(2):SetText(Resource[Settings.language][116]);
	annotWindow.TypeList.ListData:GetItem(3):SetText(Resource[Settings.language][155]);
	annotWindow.TypeList.ListData:GetItem(4):SetText(Resource[Settings.language][156]);
	annotWindow.TypeList.ListData:GetItem(5):SetText(Resource[Settings.language][157]);
	annotWindow.TypeList.ListData:GetItem(6):SetText(Resource[Settings.language][162]);

	annotWindow.AllegianceNA:SetText(Resource[Settings.language][199]);
	annotWindow.AllegianceCaption:SetText(Resource[Settings.language][67]..":");
	annotWindow.AllegianceList.ListData:GetItem(1):SetText(Resource[Settings.language][198]); -- none
	annotWindow.AllegianceList.ListData:GetItem(2):SetText(Resource[Settings.language][68]); -- creep
	annotWindow.AllegianceList.ListData:GetItem(3):SetText(Resource[Settings.language][69]); -- freep
	annotWindow.AllegianceList.ListData:GetItem(4):SetText(Resource[Settings.language][70]); -- delving
	for k,v in ipairs(craftTier) do
		annotWindow.DataTier.ListData:GetItem(k):SetText(v[Settings.language])
	end
	annotWindow.NSCoordCaption:SetText(Resource[Settings.language][75]..":");
	annotWindow.EWCoordCaption:SetText(Resource[Settings.language][76]..":");
	annotWindow.NameCaption:SetText(Resource[Settings.language][77]..":");
	annotWindow.DescriptionCaption:SetText(Resource[Settings.language][78]..":");
	annotWindow.DeleteButton:SetText(Resource[Settings.language][84]);
end
annotWindow.MouseClick=function(sender,args)
	annotWindow.AnnotationList:HideList();
	annotWindow.TypeList:HideList();
end
