-- problem with moving icon if QS has mouse focus :(
-- need to hide QS when shift/ctrl/alt key is down? and let window handle movement by letting mouse events pass through to window?
-- then need to redisplay QS when mouse leaves window?
-- not sure there is any way to make trade off seemless

minWindow=Turbine.UI.Window()
minWindow:SetVisible(false);
minWindow:SetSize(32,32);
-- local state variables
minWindow.hasMouse=false
minWindow.MoveX=-1
minWindow.MoveY=0
minWindow.Moving=false
-- create quickslot first so that the image will automatically be displayed on top of it
minWindow.QS=Turbine.UI.Lotro.Quickslot()
minWindow.QS:SetParent(minWindow)
minWindow.QS:SetSize(66,66)
minWindow.QS:SetPosition(-34,-34)
minWindow.QS:SetAllowDrop(false)
local locSC=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "")
if locale=="en" then
	locSC:SetData("/loc") -- resource[1][210]
elseif locale=="fr" then
	locSC:SetData("/emp")
elseif locale=="de" then
	locSC:SetData("/pos")
end
minWindow.QS:SetShortcut(locSC)
minWindow.QS:SetVisible(true)
minWindow.QS.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itmapWindow which wipes it out
	local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "")
	-- NOTE do NOT use Settings.language to resolve the /loc command since this must depend on the actual client running, not the user's choice of UI language
	if locale=="en" then
		sc:SetData("/loc") -- resource[1][210]
	elseif locale=="fr" then
		sc:SetData("/emp")
	elseif locale=="de" then
		sc:SetData("/pos")
	end
	minWindow.QS:SetShortcut(sc)
end
minWindow.QS.MouseClick = function(sender,args)
--	no click handler, the quickslot automatically sends the /loc to chat and the state of minWindow.hasMouse does the rest
end
minWindow.QS.MouseDown=function(sender,args)
Turbine.Shell.WriteLine("QS MouseDown")
	if minWindow.Icon:IsControlKeyDown() or minWindow.Icon:IsShiftKeyDown() or minWindow.Icon:IsAltKeyDown() then
		minWindow.Icon:SetBackground(minWindow.HoverImage);
		minWindow.MoveX=args.X;
		minWindow.MoveY=args.Y;
	end
end
minWindow.QS.MouseUp=function(sender,args)
	minWindow.Icon:SetBackground(minWindow.UpImage);
	minWindow.MoveX=-1;
	minWindow.MoveY=0;
end
minWindow.QS.MouseEnter=function(sender,args)
	minWindow.hasMouse=true
	minWindow:SetOpacity(1)
end

minWindow.QS.MouseLeave=function(sender,args)
	minWindow.hasMouse=false
	minWindow:SetOpacity(minWindow.DefaultOpacity)
end
minWindow.QS.MouseMove=function(sender,args)
	if minWindow.MoveX~=-1 and (args.X~=minWindow.MoveX or args.Y~= minWindow.MoveY) then
		minWindow.Icon:SetBackground(minWindow.DragImage);
		minWindow.Moving=true;
		local newLeft=minWindow:GetLeft()-(minWindow.MoveX-args.X)
		local newTop=minWindow:GetTop()-(minWindow.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-minWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-minWindow:GetWidth() end;
		if newTop<0 then newTop=0 end;
		if newTop>(Turbine.UI.Display.GetHeight()-minWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-minWindow:GetHeight() end;
		minWindow:SetPosition(newLeft,newTop);
		optionsCanvas.IconLeftValue:SetText(tostring(minWindow:GetLeft()))
		optionsCanvas.IconTopValue:SetText(tostring(minWindow:GetTop()))
	end
end

minWindow.Icon=Turbine.UI.Control()
minWindow.Icon:SetParent(minWindow)
minWindow.UpImage="GaranStuff/MoorMap/Resources/map_up.jpg"
minWindow.DragImage="GaranStuff/MoorMap/Resources/map_up.jpg"
minWindow.HoverImage="GaranStuff/MoorMap/Resources/map_up.jpg"
minWindow.UseMiniIcon=false;
minWindow.DefaultOpacity=.3;
minWindow.MiniIconOpaque=true;

local left=1;
local top=Turbine.UI.Display.GetHeight()-minWindow:GetHeight()-1;

if tostring(type(Settings))=="table" then
	top=euroNormalize(Settings.IconTopPercent)
	if top==nil then
		top=euroNormalize(Settings.IconTop)
	else
		top=top*Turbine.UI.Display.GetHeight();
	end
	if top==nil then top=0 end
	left=euroNormalize(Settings.IconLeftPercent)
	if left==nil then
		left=euroNormalize(Settings.IconLeft)
	else
		left=left*Turbine.UI.Display.GetWidth();
	end
	if left==nil then left=0 end
	if Settings.UseMiniIcon~=nil and Settings.UseMiniIcon==true then
		minWindow.UseMiniIcon=true;
		minWindow.UpImage="GaranStuff/MoorMap/Resources/mini_icon.tga";
		minWindow.DragImage="GaranStuff/MoorMap/Resources/mini_icon.tga";
		minWindow.HoverImage="GaranStuff/MoorMap/Resources/mini_hover.tga";
	end
	if Settings.MiniIconOpaque~=nil and Settings.MiniIconOpaque==false then
		minWindow.MiniIconOpaque=false;
	end
	-- account for changed resolution
	if left<0 then left=0 end;
	if left>(Turbine.UI.Display.GetWidth()-minWindow:GetWidth()) then left=Turbine.UI.Display.GetWidth()-minWindow:GetWidth() end;
	if top<0 then top=0 end;
	if top>(Turbine.UI.Display.GetHeight()-minWindow:GetHeight()) then top=Turbine.UI.Display.GetHeight()-minWindow:GetHeight() end;
end
if minWindow.UseMiniIcon then
	minWindow:SetSize(16,16);
end
minWindow.Icon:SetSize(minWindow:GetSize())
minWindow.Icon:SetBackground(minWindow.UpImage)
--minWindow:SetBackground(minWindow.UpImage);
if minWindow.UseMiniIcon and minWindow.MiniIconOpaque then
	minWindow.DefaultOpacity=1;
else
	minWindow.DefaultOpacity=.3;
end
minWindow:SetOpacity(minWindow.DefaultOpacity);
minWindow:SetPosition( left, top );
minWindow:SetZOrder(minWindow:GetZOrder()+1);

minWindow.Icon.MouseClick = function(sender,args)
	minWindow.Icon:SetBackground(minWindow.UpImage);
	if minWindow.Moving then
		minWindow.Moving=false;
		minWindow.MoveX=-1;
	else
		minWindow:SetVisible(false);
		mapWindow:SetVisible(true);
	end
end

minWindow.Icon.MouseDown=function(sender,args)
	if minWindow.Icon:IsControlKeyDown() or minWindow.Icon:IsShiftKeyDown() or minWindow.Icon:IsAltKeyDown() then
		minWindow.Icon:SetBackground(minWindow.HoverImage);
		minWindow.MoveX=args.X;
		minWindow.MoveY=args.Y;
	end
end
minWindow.Icon.MouseUp=function(sender,args)
	minWindow.Icon:SetBackground(minWindow.UpImage);
	minWindow.MoveX=-1;
	minWindow.MoveY=0;
end

minWindow.Icon.MouseEnter=function(sender,args)
	minWindow.hasMouse=false
	minWindow:SetOpacity(1);
end

minWindow.Icon.MouseLeave=function(sender,args)
	minWindow.hasMouse=false
	minWindow:SetOpacity(minWindow.DefaultOpacity);
end

minWindow.Icon.MouseMove=function(sender,args)
	if minWindow.MoveX~=-1 and (args.X~=minWindow.MoveX or args.Y~= minWindow.MoveY) then
		minWindow.Icon:SetBackground(minWindow.DragImage);
		minWindow.Moving=true;
		local newLeft=minWindow:GetLeft()-(minWindow.MoveX-args.X)
		local newTop=minWindow:GetTop()-(minWindow.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-minWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-minWindow:GetWidth() end;
		if newTop<0 then newTop=0 end;
		if newTop>(Turbine.UI.Display.GetHeight()-minWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-minWindow:GetHeight() end;
		minWindow:SetPosition(newLeft,newTop);
		optionsCanvas.IconLeftValue:SetText(tostring(minWindow:GetLeft()))
		optionsCanvas.IconTopValue:SetText(tostring(minWindow:GetTop()))
	end
end

minWindow.Update=function(sender,args)
	minWindow.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
end
minWindow.GetUseMiniIcon=function()
	return minWindow.UseMiniIcon;
end
minWindow.SetUseMiniIcon=function(sender,value)
	minWindow.UseMiniIcon=value;
	if value==true then
		minWindow.UpImage="GaranStuff/MoorMap/Resources/mini_icon.tga";
		minWindow.DragImage="GaranStuff/MoorMap/Resources/mini_icon.tga";
		minWindow.HoverImage="GaranStuff/MoorMap/Resources/mini_hover.tga";
	else
		minWindow.UpImage="GaranStuff/MoorMap/Resources/map_up.jpg"
		minWindow.DragImage="GaranStuff/MoorMap/Resources/map_up.jpg"
		minWindow.HoverImage="GaranStuff/MoorMap/Resources/map_up.jpg"
	end
	if minWindow.UseMiniIcon and minWindow.MiniIconOpaque then
		minWindow.DefaultOpacity=1;
	else
		minWindow.DefaultOpacity=.3;
	end
	minWindow:SetOpacity(minWindow.DefaultOpacity);
	if minWindow.UseMiniIcon then
		minWindow.Icon:SetSize(16,16);
	else
		minWindow.Icon:SetSize(32,32);
	end
	minWindow.Icon:SetBackground(minWindow.UpImage);
end
minWindow.GetMiniIconOpaque=function()
	return minWindow.MiniIconOpaque;
end
minWindow.SetMiniIconOpaque=function(sender,value)
	minWindow.MiniIconOpaque=value;
	if minWindow.UseMiniIcon and minWindow.MiniIconOpaque then
		minWindow.DefaultOpacity=1;
	else
		minWindow.DefaultOpacity=.3;
	end
	minWindow:SetOpacity(minWindow.DefaultOpacity);
end
--minWindow.Icon:SetMouseVisible(false)