-- icons have three states, 0=unchecked, 1=checked & empty, 2=checked & active
-- note, fixed threats will always be state=2

tmp.HTScript=function(tmpData,tmpOLIndex)
	local success,result
	local topmost=100+#mapWindow.Map.Icons
	local isvisible=tmpData[8]
	local htWidth=320
	local htHeight=420
	if (HTLegend.HT==nil or HTLegend.HT[1]==nil) then
		HT={}
		legend={}
		success,result=pcall(import,importPath.."Overlays.HT.Data"..tostring(mapWindow.CurrentMapID));
		HTLegend.HT=HT
		if htStates[mapWindow.CurrentMapID]~=nil then
			-- add state info from saved state
			for k,v in ipairs(HTLegend.HT) do
				-- note, it is imperative that the order of hidden threat data does not change since it is tied to the custom states by the same index
				if htStates[mapWindow.CurrentMapID][v[1]]~=nil then
					HTLegend.HT[k][6]=htStates[mapWindow.CurrentMapID][v[1]]
				end
			end
		end
		if HTLegend.initialized==nil then
			HTLegend.VisibleChanged=function()
				if HTLegend:IsVisible() then
					-- add a nonsense string to the filter - this will cause all icons to be removed
					mapWindow.Map.IconSearch:SetText(mapWindow.Map.IconSearch:GetText()..string.char(10))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				else
					-- remove the nonsense string from the filter
					mapWindow.Map.IconSearch:SetText(string.gsub(mapWindow.Map.IconSearch:GetText(),string.char(10),""))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				end
			end
			HTLegend.popupMenu=Turbine.UI.ContextMenu()
			local tmpList=HTLegend.popupMenu:GetItems()
			local tmpItem=Turbine.UI.MenuItem("Set Unchecked")
			tmpItem.Click=function(sender)
				HTLegend.SetUnchecked(HTLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			tmpItem=Turbine.UI.MenuItem("Set Checked - No HT")
			tmpItem.Click=function(sender)
				HTLegend.SetChecked(HTLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			if HTLegend.HT.names~=nil then
				for k,v in ipairs(HTLegend.HT.names) do
					tmpItem=Turbine.UI.MenuItem(v)
					tmpItem.text=v
					if htStates[mapWindow.CurrentMapID]~=nil then
						for index,data in pairs(htStates[mapWindow.CurrentMapID]) do
							if data==v then
								tmpItem:SetEnabled(false)
								break
							end
						end
					end
					tmpItem.Click=function(sender)
						HTLegend.SetActive(HTLegend.currentIndex,sender.text)
					end
					tmpList:Add(tmpItem)
				end
			end

			HTLegend.initialized=true
			HTLegend.IconSize={}
			HTLegend.IconSize[16]={{26,16},{26,16},{26,16}}
			HTLegend.IconSize[24]={{38,24},{38,24},{38,24}}
			HTLegend.IconSize[32]={{51,32},{51,32},{51,32}}
			HTLegend.IconSize[40]={{64,40},{64,40},{64,40}}
			HTLegend.IconSize[48]={{77,48},{77,48},{77,48}}

			HTLegend:SetPosition(Settings.HTLegendLeftPercent*displayWidth,Settings.HTLegendTopPercent*displayHeight)
			if legend.width~=nil then
				htWidth=legend.width
			end
			HTLegend:SetSize(htWidth,htHeight)
			HTLegend:SetZOrder(mapWindow:GetZOrder()+1)
			HTLegend:SetOpacity(.95)
			HTLegend:SetZOrder(2)
			HTLegend:SetStretchMode(3);
			HTVis=isvisible
			HTLegend:SetVisible(isvisible and mapWindow:IsVisible())
			HTLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			HTLegend.Border=Turbine.UI.Control()
			HTLegend.Border:SetParent(HTLegend)
			HTLegend.Border:SetSize(htWidth-2,htHeight-2)
			HTLegend.Border:SetPosition(1,1)
			if legend.backColor==nil then
				HTLegend.Border.backColor=Turbine.UI.Color(.95,.95,.85)
				HTLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
			else
				HTLegend.Border.backColor=legend.backColor
				HTLegend.Border:SetBackColor(legend.backColor)
			end
			HTLegend.TitleBack=Turbine.UI.Control()
			HTLegend.TitleBack:SetParent(HTLegend.Border)
			HTLegend.TitleBack:SetSize(htWidth,65)
			HTLegend.Title=Turbine.UI.Control()
			HTLegend.Title:SetParent(HTLegend.TitleBack)
			HTLegend.Title:SetSize(250,65)
			HTLegend.Title:SetPosition((htWidth-252)/2,1)
			HTLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if legend.caption==nil then
				HTLegend.Title:SetBackground(resourcePath.."HiddenThreats.tga")
			else
				HTLegend.Title:SetBackground("GaranStuff/MoorMap/Overlays/"..legend.caption)
			end
			HTLegend.Title:SetMouseVisible(false)
			HTLegend.TitleBack.MouseDown=function(sender,args)
				local color=HTLegend.Border:GetBackColor()
				color.A=.8
				HTLegend.Border:SetBackColor(color)
				HTLegend.X=args.X
				HTLegend.Y=args.Y
				HTLegend.Moving=true
			end
			HTLegend.TitleBack.MouseMove=function(sender,args)
				if HTLegend.Moving then
					HTLegend:SetPosition(HTLegend:GetLeft()-(HTLegend.X-args.X),HTLegend:GetTop()-(HTLegend.Y-args.Y))
				end
			end
			HTLegend.TitleBack.MouseUp=function(sender,args)
				HTLegend.Border:SetBackColor(HTLegend.Border.backColor)
				HTLegend.Moving=false
			end
			HTLegend.TitleBack.MouseLeave=function(sender,args)
				HTLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
				HTLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			end
			HTLegend.TitleBack.MouseEnter=function(sender,args)
				HTLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
				HTLegend:SetBackColor(nil)
			end
			HTLegend.FontCaption=Turbine.UI.Label()
			HTLegend.FontCaption:SetParent(HTLegend.Border)
			HTLegend.FontCaption:SetSize(100,20)
			HTLegend.FontCaption:SetPosition(2,72)
			if legend.fontForeColor==nil then legend.fontForeColor=Turbine.UI.Color(.2,.5,.2) end
			HTLegend.FontCaption:SetForeColor(legend.fontForeColor)
			HTLegend.FontCaption:SetText(Resource[Settings.language][345]..":")
			if Settings.HTIconSize<48 then
				HTLegend.FontIncrease=Turbine.UI.Label()
				HTLegend.FontIncrease:SetParent(HTLegend.Border)
				HTLegend.FontIncrease:SetSize(20,20)
				HTLegend.FontIncrease:SetPosition(107,72)
				HTLegend.FontIncrease:SetForeColor(legend.fontForeColor)
				HTLegend.FontIncrease:SetText("+")
				HTLegend.FontIncrease.MouseClick=function(sender,args)
					Settings.HTIconSize=Settings.HTIconSize+8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end
			HTLegend.FontSizeCaption=Turbine.UI.Label()
			HTLegend.FontSizeCaption:SetParent(HTLegend.Border)
			HTLegend.FontSizeCaption:SetSize(40,20)
			HTLegend.FontSizeCaption:SetPosition(127,72)
			HTLegend.FontSizeCaption:SetForeColor(legend.fontForeColor)
			HTLegend.FontSizeCaption:SetText(Settings.HTIconSize)
			if Settings.HTIconSize>16 then
				HTLegend.FontDecrease=Turbine.UI.Label()
				HTLegend.FontDecrease:SetParent(HTLegend.Border)
				HTLegend.FontDecrease:SetSize(20,20)
				HTLegend.FontDecrease:SetPosition(167,72)
				HTLegend.FontDecrease:SetForeColor(legend.fontForeColor)
				HTLegend.FontDecrease:SetText("-")
				HTLegend.FontDecrease.MouseClick=function(sender,args)
					Settings.HTIconSize=Settings.HTIconSize-8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end

			HTLegend.Reset=Turbine.UI.Lotro.Button()
			HTLegend.Reset:SetParent(HTLegend.Border)
			HTLegend.Reset:SetSize(150,20)
			HTLegend.Reset:SetPosition(HTLegend.Border:GetWidth()/2-HTLegend.Reset:GetWidth()/2,90)
			HTLegend.Reset:SetText(Resource[Settings.language][500])
			HTLegend.Reset.MouseClick=function()
				-- only wipe out numeric keys (we want to preserve the .lastChannel and .lastName values
				for k,v in pairs(htStates) do
					if type(k)=="number" then
						htStates[k]=nil
					end
				end
				mapWindow.PreserveMapID=true;
				Turbine.PluginManager.LoadPlugin("MoorMapLoader");				
			end

			HTLegend.HTList=Turbine.UI.ListBox()
			HTLegend.HTList:SetParent(HTLegend.Border)
			HTLegend.HTList:SetSize(htWidth-24,htHeight-117)
			HTLegend.HTList:SetPosition(5,115)
			HTVScroll=Turbine.UI.Lotro.ScrollBar()
			HTVScroll:SetParent(HTLegend.Border)
			HTVScroll:SetSize(10,HTLegend.HTList:GetHeight());
			HTVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
			HTVScroll:SetPosition(htWidth-12,HTLegend.HTList:GetTop());
			HTLegend.HTList:SetVerticalScrollBar(HTVScroll)
			HTLegend.Ping=Turbine.UI.Control();
			HTLegend.Ping:SetParent(mapWindow.Map);
			HTLegend.Ping:SetZOrder(topmost+1);
			HTLegend.Ping.State=0;
			HTLegend.Ping:SetVisible(false);
			HTLegend.Ping:SetSize(23,23);
			HTLegend.Ping:SetPosition(512,512);
			HTLegend.Ping:SetWantsUpdates(false);
			HTLegend.Ping.Counter=1;
			HTLegend.Ping.MaxCounter=2;
			HTLegend.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			HTLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
			HTLegend.Ping.MouseClick=function(sender,args)
				HTLegend.Ping.State=0; -- it will auto hide itmapWindow on next tick
			end
			HTLegend.Ping.Update=function(sender)
				if HTLegend.Ping.UpdateTime==nil then
					HTLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()-.01
				end
				if HTLegend.Ping.State==0 then
					HTLegend.Ping.UpdateTime=nil
					HTLegend.Ping:SetWantsUpdates(false);
					HTLegend.Ping:SetVisible(false);
					HTLegend.Ping.Counter=0;
					HTLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
				elseif Turbine.Engine:GetGameTime()>HTLegend.Ping.UpdateTime then
					HTLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()+.01
					if HTLegend.Ping.State==7 then
						HTLegend.Ping.Counter=HTLegend.Ping.Counter+1;
						if HTLegend.Ping.Counter>HTLegend.Ping.MaxCounter then
							HTLegend.Ping.Counter=0;
							HTLegend.Ping.State=3;
							HTLegend.Ping:SetBackground(resourcePath.."Ping3.tga");
						end
					else
						HTLegend.Ping.Counter=HTLegend.Ping.Counter+1;
						if HTLegend.Ping.Counter>HTLegend.Ping.MaxCounter then
							HTLegend.Ping.Counter=0;
							HTLegend.Ping.State=HTLegend.Ping.State+1;
							HTLegend.Ping:SetBackground(resourcePath.."Ping"..tostring(HTLegend.Ping.State)..".tga");
						end
					end
				end
			end
			HTLegend.SetUnchecked=function(index)
				-- if htStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if htStates[mapWindow.CurrentMapID]~=nil and htStates[mapWindow.CurrentMapID][index]~=nil then
					local val=htStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=HTLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription="Unchecked"
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/HT/Unchecked"..tostring(Settings.HTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Unchecked
				for k=1,HTLegend.HTList:GetItemCount() do
					local item=HTLegend.HTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/HT/UncheckedIcon.tga")
						item.Title:SetText("Unchecked")
						break
					end
				end
				-- set htStates[map][index] to nil
				if htStates[mapWindow.CurrentMapID]==nil then htStates[mapWindow.CurrentMapID]={} end
				htStates[mapWindow.CurrentMapID][index]=nil
			end
			HTLegend.SetChecked=function(index)
				-- if htStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if htStates[mapWindow.CurrentMapID]~=nil and htStates[mapWindow.CurrentMapID][index]~=nil then
					local val=htStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=HTLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription="Checked"
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/HT/Checked"..tostring(Settings.HTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Checked
				for k=1,HTLegend.HTList:GetItemCount() do
					local item=HTLegend.HTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/HT/CheckedIcon.tga")
						item.Title:SetText("Checked")
						break
					end
				end
				-- set htStates[map][index] to 2
				if htStates[mapWindow.CurrentMapID]==nil then htStates[mapWindow.CurrentMapID]={} end
				htStates[mapWindow.CurrentMapID][index]=2
			end
			HTLegend.SetActive=function(index,name)
				-- if htStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if htStates[mapWindow.CurrentMapID]==nil then htStates[mapWindow.CurrentMapID]={} end
				local val=htStates[mapWindow.CurrentMapID][index]
				local items=HTLegend.popupMenu:GetItems()
				for k=3,items:GetCount() do
					if type(val)=="string" then
						if items:Get(k).text==val then
							items:Get(k):SetEnabled(true)
						end
					end
					if items:Get(k).text==name then
						items:Get(k):SetEnabled(false)
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription=name
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/HT/Confirmed"..tostring(Settings.HTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to name
				for k=1,HTLegend.HTList:GetItemCount() do
					local item=HTLegend.HTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/HT/ConfirmedIcon.tga")
						item.Title:SetText(name)
						break
					end
				end
				-- set htStates[map][index] to name
				if htStates[mapWindow.CurrentMapID]==nil then htStates[mapWindow.CurrentMapID]={} end
				htStates[mapWindow.CurrentMapID][index]=name
			end

			-- sort the list so that fixed values are at the top
			table.sort(HTLegend.HT,function(a,b) if a[1]<b[1] then return true end end)
			for htIndex,htData in ipairs(HTLegend.HT) do
				local tmpNode=Turbine.UI.Control()
				tmpNode.index=htData[1]
				tmpNode:SetParent(HTLegend.HTList)
				tmpNode:SetSize(htWidth-24,18)
				tmpNode.Icon=Turbine.UI.Control()
				tmpNode.Icon:SetParent(tmpNode)
				tmpNode.Icon:SetMouseVisible(false)
				tmpNode.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				tmpNode.Icon:SetSize(16,16)
				tmpNode.Title=Turbine.UI.Label()
				tmpNode.Title:SetParent(tmpNode)
				tmpNode.Title:SetSize(htWidth-42,18)
				tmpNode.Title:SetLeft(18)
				tmpNode.Title:SetForeColor(Turbine.UI.Color.Red)
				tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
				tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
				tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
				local imgName="Unchecked"
				local state=1
				if htData[2]==1 then
					if htData[6]==2 then
						imgName="Checked"
						state=2
					elseif htData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif htData[2]==2 then
					-- this should only ever arise during testing
					if htData[6]==2 then
						imgName="Checked"
						state=2
					elseif htData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif htData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				success,result=pcall(tmpNode.Icon.SetBackground,tmpNode.Icon,"GaranStuff/MoorMap/Overlays/HT/"..imgName.."Icon.tga")
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
					tmpNode.Title:SetText(htData[5])

				if htData[5]~=nil then
					tmpNode.Title:SetText(htData[5])
				else
					local tmpName="Unchecked"
					-- set initial text based on state
					if htStates[mapWindow.CurrentMapID]~=nil then
						if htStates[mapWindow.CurrentMapID][tmpNode.index]~=nil then
							if htStates[mapWindow.CurrentMapID][tmpNode.index]==2 then
								tmpName="Checked"
							else
								tmpName=htStates[mapWindow.CurrentMapID][tmpNode.index]
							end
						end
					end
					tmpNode.Title:SetText(tmpName)
				end
				tmpNode.X=math.floor(htData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				tmpNode.Y=math.floor(htData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
--				if NS<0 then
--					tmpHotSpot.Coords=tostring(0-NS).."S, "
--				else
--					tmpHotSpot.Coords=tostring(NS).."N, "
--				end
--				if EW<0 then
--					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
--				else
--					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
--				end
				tmpNode.Title:SetMouseVisible(false)
				if htData[2]==1 then
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							HTLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							HTLegend.Ping.State=1;
							HTLegend.Ping:SetVisible(true);
							HTLegend.Ping:SetWantsUpdates(true);
						else
							-- pop up menu with choices to change state
							HTLegend.currentIndex=sender.index
							-- hide unavailable options
							local state=1
							if htStates[mapWindow.CurrentMapID]~=nil then
								if htStates[mapWindow.CurrentMapID][sender.index]~=nil then
									state=htStates[mapWindow.CurrentMapID][sender.index]
								end
							end
							local items=HTLegend.popupMenu:GetItems()
							if state==1 then
								items:Get(1):SetEnabled(false)
								items:Get(2):SetEnabled(true)
							elseif state==2 then
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(false)
							else
								-- state will be the name of the currently selected bad guy
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(true)
							end
							local x,y=Turbine.UI.Display:GetMousePosition()
							HTLegend.popupMenu:ShowMenuAt(x,y)
						end
					end
				else
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							HTLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							HTLegend.Ping.State=1;
							HTLegend.Ping:SetVisible(true);
							HTLegend.Ping:SetWantsUpdates(true);
						end
					end
				end
				HTLegend.HTList:AddItem(tmpNode)
			end
		end
	end

	mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
	for itemIndex,itemData in ipairs(HTLegend.HT) do
			-- add the hotspot to the overlay
			if itemData[2]~=nil and itemData[3]~=nil and itemData[4]~=nil then
				local NS,EW=itemData[3],itemData[4]
				local X,Y
				X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);

				local tmpHotSpot=Turbine.UI.Control()
				tmpHotSpot.index=itemData[1]
				-- if the hotspots are on the overlay we don't get mouse events :(
				tmpHotSpot:SetParent(mapWindow.Map)
				tmpHotSpot:SetVisible(isvisible)
				tmpHotSpot:SetZOrder(topmost)

				tmpHotSpot:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				local imgName="Unchecked"
				local state=1
				if itemData[2]==1 then
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==2 then
					-- this should only ever arise during testing
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				tmpHotSpot:SetWidth(HTLegend.IconSize[Settings.HTIconSize][state][1])
				tmpHotSpot:SetHeight(HTLegend.IconSize[Settings.HTIconSize][state][2])
				success,result=pcall(tmpHotSpot.SetBackground,tmpHotSpot,"GaranStuff/MoorMap/Overlays/HT/"..imgName..tostring(Settings.HTIconSize)..".tga")
				tmpHotSpot:SetPosition(X-HTLegend.IconSize[Settings.HTIconSize][state][1]/2,Y-HTLegend.IconSize[Settings.HTIconSize][state][2]/2)
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
				if itemData[5]~=nil then
					tmpHotSpot.ShortDescription=itemData[5]
				else
					-- set initial text based on state
					tmpHotSpot.ShortDescription="Unchecked"
					if htStates[mapWindow.CurrentMapID]~=nil then
						if htStates[mapWindow.CurrentMapID][tmpHotSpot.index]~=nil then
							if htStates[mapWindow.CurrentMapID][tmpHotSpot.index]==2 then
								tmpHotSpot.ShortDescription="Checked"
							else
								tmpHotSpot.ShortDescription=htStates[mapWindow.CurrentMapID][tmpHotSpot.index]
							end
						end
					end
				end
				if NS<0 then
					tmpHotSpot.Coords=tostring(0-NS).."S, "
				else
					tmpHotSpot.Coords=tostring(NS).."N, "
				end
				if EW<0 then
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
				else
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
				end
				if itemData[2]==1 then
					tmpHotSpot.MouseClick=function(sender,args)
						-- pop up menu with choices to change state
						HTLegend.currentIndex=sender.index
						-- hide unavailable options
						local state=1
						if htStates[mapWindow.CurrentMapID]~=nil then
							if htStates[mapWindow.CurrentMapID][sender.index]~=nil then
								state=htStates[mapWindow.CurrentMapID][sender.index]
							end
						end
						local items=HTLegend.popupMenu:GetItems()
						if state==1 then
							items:Get(1):SetEnabled(false)
							items:Get(2):SetEnabled(true)
						elseif state==2 then
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(false)
						else
							-- state will be the name of the currently selected bad guy
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(true)
						end
						local x,y=Turbine.UI.Display:GetMousePosition()
						HTLegend.popupMenu:ShowMenuAt(x,y)
					end
				end
--				tmpHotSpot.MouseEnter=function(sender)
--					sender.Text:SetBackColor(Turbine.UI.Color(.9,.9,.9))
--				end
--				tmpHotSpot.MouseLeave=function(sender)
--					sender.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
--				end
				tmpHotSpot.MouseHover=function(sender)
					HTHotSpotHover(sender)
				end
				table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
			end
	end
end