-- TODO
-- add chat listener - this listener should really handle RT, HT (if needed) and WB (if needed) overlays to avoid having too many listeners registered

-- add a checkbox to make suppressing annotations optional?
-- -- if overlay is displayed when checkbox is changed (pretty much has to be), reapply/remove the visibility filter

-- possible icons:
-- eye icon, 25x25 0x41103549, 26x24 0x4110d9ac
-- eye banner 30x30 0x41164aeb
-- skull on red back, 62x31 0x410ff888
-- dull back without skull , 62x31 0x410ff958 (suitable for creating custom icon...)
-- question icon, 32x32 0x41000000
-- checked icon, 16x16 0x41000007
-- red skull 16x16 0x4101f893

-- diamonds 37x37, blue 0x410e8e5c, green 0x410e8e5d, red 0x410e9147, teal? 0x410e917a, pink 0x410f4b94, orange 0x410f4b95, yellow 0x410f4b96

--0x4110ede3
--[[
iWin=Turbine.UI.Window()
iWin:SetSize(400,400)
iWin:SetBackColor(Turbine.UI.Color(1,0,0,0))
iWin:SetVisible(true)
iImg=Turbine.UI.Control()
iImg:SetParent(iWin)
iImg:SetPosition(200,200)
iImg:SetBlendMode(Turbine.UI.BlendMode.Overlay)
iImg.SetImage=function(img)
	iImg:SetBackground(img)
	iImg:SetStretchMode(2)
	x,y=iImg:GetSize()
	iImg:SetStretchMode(0)
	iImg:SetSize(x,y)
end

iImg.SetImage(0x410ff958)

iImg.SetImage("GaranStuff/MoorMap/Overlays/RT/Confirmed24.tga")
]]--

-- icons have three states, 0=unchecked, 1=checked & empty, 2=checked & active
-- note, fixed threats will always be state=2

tmp.RTScript=function(tmpData,tmpOLIndex)
	local success,result
	local topmost=100+#mapWindow.Map.Icons
	local isvisible=tmpData[8]
	local rtWidth=320
	local rtHeight=420
	if (RTLegend.RT==nil or RTLegend.RT[1]==nil) then
		RT={}
		legend={}
		success,result=pcall(import,importPath.."Overlays.RT.Data"..tostring(mapWindow.CurrentMapID));
		RTLegend.RT=RT
		if rtStates[mapWindow.CurrentMapID]~=nil then
			-- add state info from saved state
			for k,v in ipairs(RTLegend.RT) do
				-- note, it is imperative that the order of roving threat data does not change since it is tied to the custom states by the same index
				if rtStates[mapWindow.CurrentMapID][v[1]]~=nil then
					RTLegend.RT[k][6]=rtStates[mapWindow.CurrentMapID][v[1]]
				end
			end
		end
		if RTLegend.initialized==nil then
			RTLegend.VisibleChanged=function()
				if RTLegend:IsVisible() then
					-- add a nonsense string to the filter - this will cause all icons to be removed
					mapWindow.Map.IconSearch:SetText(mapWindow.Map.IconSearch:GetText()..string.char(10))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				else
					-- remove the nonsense string from the filter
					mapWindow.Map.IconSearch:SetText(string.gsub(mapWindow.Map.IconSearch:GetText(),string.char(10),""))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				end
			end
			RTLegend.popupMenu=Turbine.UI.ContextMenu()
			local tmpList=RTLegend.popupMenu:GetItems()
			local tmpItem=Turbine.UI.MenuItem(Resource[Settings.language][501])
			tmpItem.Click=function(sender)
				RTLegend.SetUnchecked(RTLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			tmpItem=Turbine.UI.MenuItem(Resource[Settings.language][502])
			tmpItem.Click=function(sender)
				RTLegend.SetChecked(RTLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			if RTLegend.RT.names~=nil then
				for k,v in ipairs(RTLegend.RT.names) do
					tmpItem=Turbine.UI.MenuItem(v)
					tmpItem.text=v
					if rtStates[mapWindow.CurrentMapID]~=nil then
						for index,data in pairs(rtStates[mapWindow.CurrentMapID]) do
							if data==v then
								tmpItem:SetEnabled(false)
								break
							end
						end
					end
					tmpItem.Click=function(sender)
						RTLegend.SetActive(RTLegend.currentIndex,sender.text)
					end
					tmpList:Add(tmpItem)
				end
			end

			RTLegend.initialized=true
			RTLegend.IconSize={}
			RTLegend.IconSize[16]={{26,16},{26,16},{26,16}}
			RTLegend.IconSize[24]={{38,24},{38,24},{38,24}}
			RTLegend.IconSize[32]={{51,32},{51,32},{51,32}}
			RTLegend.IconSize[40]={{64,40},{64,40},{64,40}}
			RTLegend.IconSize[48]={{77,48},{77,48},{77,48}}

			RTLegend:SetPosition(Settings.RTLegendLeftPercent*displayWidth,Settings.RTLegendTopPercent*displayHeight)
			if legend.width~=nil then
				rtWidth=legend.width
			end
			RTLegend:SetSize(rtWidth,rtHeight)
			RTLegend:SetZOrder(mapWindow:GetZOrder()+1)
			RTLegend:SetOpacity(.95)
			RTLegend:SetZOrder(2)
			RTLegend:SetStretchMode(3);
			RTVis=isvisible
			RTLegend:SetVisible(isvisible and mapWindow:IsVisible())
			RTLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			RTLegend.Border=Turbine.UI.Control()
			RTLegend.Border:SetParent(RTLegend)
			RTLegend.Border:SetSize(rtWidth-2,rtHeight-2)
			RTLegend.Border:SetPosition(1,1)
			if legend.backColor==nil then
				RTLegend.Border.backColor=Turbine.UI.Color(.95,.95,.85)				
				RTLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
			else
				RTLegend.Border.backColor=legend.backColor
				RTLegend.Border:SetBackColor(legend.backColor)
			end
			RTLegend.TitleBack=Turbine.UI.Control()
			RTLegend.TitleBack:SetParent(RTLegend.Border)
			RTLegend.TitleBack:SetSize(rtWidth,65)
			RTLegend.Title=Turbine.UI.Control()
			RTLegend.Title:SetParent(RTLegend.TitleBack)
			RTLegend.Title:SetSize(250,65)
			RTLegend.Title:SetPosition((rtWidth-252)/2,1)
			RTLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if legend.caption==nil then
				RTLegend.Title:SetBackground(resourcePath.."RTCaptionMathwold.tga")
			else
				RTLegend.Title:SetBackground("GaranStuff/MoorMap/Overlays/"..legend.caption)
			end
			RTLegend.Title:SetMouseVisible(false)
			RTLegend.TitleBack.MouseDown=function(sender,args)
				local color=RTLegend.Border:GetBackColor()
				color.A=.8
				RTLegend.Border:SetBackColor(color)
				RTLegend.X=args.X
				RTLegend.Y=args.Y
				RTLegend.Moving=true
			end
			RTLegend.TitleBack.MouseMove=function(sender,args)
				if RTLegend.Moving then
					RTLegend:SetPosition(RTLegend:GetLeft()-(RTLegend.X-args.X),RTLegend:GetTop()-(RTLegend.Y-args.Y))
				end
			end
			RTLegend.TitleBack.MouseUp=function(sender,args)
				RTLegend.Border:SetBackColor(RTLegend.Border.backColor)
				RTLegend.Moving=false
			end
			RTLegend.TitleBack.MouseLeave=function(sender,args)
				RTLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
				RTLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			end
			RTLegend.TitleBack.MouseEnter=function(sender,args)
				RTLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
				RTLegend:SetBackColor(nil)
			end
			RTLegend.FontCaption=Turbine.UI.Label()
			RTLegend.FontCaption:SetParent(RTLegend.Border)
			RTLegend.FontCaption:SetSize(100,20)
			RTLegend.FontCaption:SetPosition(2,72)
			if legend.fontForeColor==nil then legend.fontForeColor=Turbine.UI.Color(.2,.5,.2) end
			RTLegend.FontCaption:SetForeColor(legend.fontForeColor)
			RTLegend.FontCaption:SetText(Resource[Settings.language][345]..":")
			if Settings.RTIconSize<48 then
				RTLegend.FontIncrease=Turbine.UI.Label()
				RTLegend.FontIncrease:SetParent(RTLegend.Border)
				RTLegend.FontIncrease:SetSize(20,20)
				RTLegend.FontIncrease:SetPosition(107,72)
				RTLegend.FontIncrease:SetForeColor(legend.fontForeColor)
				RTLegend.FontIncrease:SetText("+")
				RTLegend.FontIncrease.MouseClick=function(sender,args)
					Settings.RTIconSize=Settings.RTIconSize+8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end
			RTLegend.FontSizeCaption=Turbine.UI.Label()
			RTLegend.FontSizeCaption:SetParent(RTLegend.Border)
			RTLegend.FontSizeCaption:SetSize(40,20)
			RTLegend.FontSizeCaption:SetPosition(127,72)
			RTLegend.FontSizeCaption:SetForeColor(legend.fontForeColor)
			RTLegend.FontSizeCaption:SetText(Settings.RTIconSize)
			if Settings.RTIconSize>16 then
				RTLegend.FontDecrease=Turbine.UI.Label()
				RTLegend.FontDecrease:SetParent(RTLegend.Border)
				RTLegend.FontDecrease:SetSize(20,20)
				RTLegend.FontDecrease:SetPosition(167,72)
				RTLegend.FontDecrease:SetForeColor(legend.fontForeColor)
				RTLegend.FontDecrease:SetText("-")
				RTLegend.FontDecrease.MouseClick=function(sender,args)
					Settings.RTIconSize=Settings.RTIconSize-8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end
			RTLegend.Reset=Turbine.UI.Lotro.Button()
			RTLegend.Reset:SetParent(RTLegend.Border)
			RTLegend.Reset:SetSize(150,20)
			RTLegend.Reset:SetPosition(RTLegend.Border:GetWidth()/2-RTLegend.Reset:GetWidth()/2,90)
			RTLegend.Reset:SetText(Resource[Settings.language][500])
			RTLegend.Reset.MouseClick=function()
				-- wipe out values with numeric keys (we want to preserve the values with alpha keys such as .lastChannel and .lastName)
				for k,v in pairs(rtStates) do
					if type(k)=="number" then
						rtStates[k]=nil
					end
				end
				mapWindow.PreserveMapID=true;
				Turbine.PluginManager.LoadPlugin("MoorMapLoader");				
			end
			RTLegend.ShareChannel=DropDownList()
			RTLegend.ShareChannel:SetParent(RTLegend.Border)
			RTLegend.ShareChannel:SetSize(200,20)
			RTLegend.ShareChannel:SetPosition(5,115)
			RTLegend.ShareChannel:SetBackColor(Turbine.UI.Color.Black)
			RTLegend.ShareChannel:AddItem(Resource[Settings.language][504],Resource[Settings.language][503])
			RTLegend.ShareChannel:AddItem(Resource[Settings.language][506],Resource[Settings.language][505])
			RTLegend.ShareChannel:AddItem("UC1","/1 ")
			RTLegend.ShareChannel:AddItem("UC2","/2 ")
			RTLegend.ShareChannel:AddItem("UC3","/3 ")
			RTLegend.ShareChannel:AddItem("UC4","/4 ")
			RTLegend.ShareChannel:AddItem("UC5","/5 ")
			RTLegend.ShareChannel:AddItem("UC6","/6 ")
			RTLegend.ShareChannel:AddItem("UC7","/7 ")
			RTLegend.ShareChannel:AddItem("UC8","/8 ")
			RTLegend.ShareChannel:AddItem(Resource[Settings.language][508],Resource[Settings.language][507])
			if rtStates.lastChannel==nil then
				RTLegend.ShareChannel:SetSelectedIndex(1)
			else
				for k=1,RTLegend.ShareChannel.ListData:GetItemCount() do
					if RTLegend.ShareChannel.ListData:GetItem(k):GetValue()==rtStates.lastChannel then
						RTLegend.ShareChannel:SetSelectedIndex(k)
						break
					end
				end
			end
			RTLegend.ShareChannel:SetZOrder(2)
			RTLegend.ShareName=Turbine.UI.Lotro.TextBox()
			RTLegend.ShareName:SetParent(RTLegend.Border)
			RTLegend.ShareName:SetSize(RTLegend.Border:GetWidth()-230,20)
			RTLegend.ShareName:SetPosition(205,115)
			RTLegend.ShareName:SetFont(Turbine.UI.Lotro.Font.Verdana16)
			if rtStates.lastName~=nil then
				RTLegend.ShareName:SetText(rtStates.lastName)
			end
			RTLegend.ShareQS=Turbine.UI.Lotro.Quickslot()
			RTLegend.ShareQS:SetParent(RTLegend.Border)
			RTLegend.ShareQS:SetSize(20,20)
			RTLegend.ShareQS:SetPosition(RTLegend.Border:GetWidth()-25,115)
			RTLegend.ShareQS:SetAllowDrop(false);
			RTLegend.ShareQS.MouseEnter=function()
				local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
				local tmpTxt=RTLegend.ShareChannel:GetValue().." "
				if RTLegend.ShareChannel:GetValue()==Resource[Settings.language][507] then
					tmpTxt=tmpTxt..RTLegend.ShareName:GetText().." "
				end
				local tmpTbl1={}
				local tmpTbl2={}
				if rtStates[mapWindow.CurrentMapID]~=nil then
					for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
						if v.index~=nil and rtStates[mapWindow.CurrentMapID][v.index]~=nil and rtStates[mapWindow.CurrentMapID][v.index]~=2 then
							table.insert(tmpTbl1,v.Coords)
							table.insert(tmpTbl2,rtStates[mapWindow.CurrentMapID][v.index])
						end
					end
				end
				tmpTxt=tmpTxt..RTMaps[mapWindow.CurrentMapID][1].."RT: "..table.concat(tmpTbl1,", ").." {"..table.concat(tmpTbl2,":").."}"
				sc:SetData(tmpTxt)
				RTLegend.ShareQS:SetShortcut(sc);
			end
			quickWindow.Quickslot.DragDrop=function()
				RTLegend.ShareQS.MouseEnter();
			end
			RTLegend.ShareMask=Turbine.UI.Control()
			RTLegend.ShareMask:SetParent(RTLegend.Border)
			RTLegend.ShareMask:SetSize(20,20)
			RTLegend.ShareMask:SetPosition(RTLegend.Border:GetWidth()-25,115)
			RTLegend.ShareMask:SetBackColor(RTLegend.Border:GetBackColor())
			RTLegend.ShareMask:SetMouseVisible(false)
			RTLegend.ShareIcon=Turbine.UI.Control()
			RTLegend.ShareIcon:SetParent(RTLegend.ShareMask)
			RTLegend.ShareIcon:SetSize(RTLegend.ShareMask:GetSize())
			RTLegend.ShareIcon:SetPosition(0,0)
			RTLegend.ShareIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			RTLegend.ShareIcon:SetBackground("GaranStuff/MoorMap/Overlays/RT/Share.tga")
			RTLegend.ShareIcon:SetMouseVisible(false)

			RTLegend.RTList=Turbine.UI.ListBox()
			RTLegend.RTList:SetParent(RTLegend.Border)
			RTLegend.RTList:SetSize(rtWidth-24,rtHeight-142)
			RTLegend.RTList:SetPosition(5,140)
			RTVScroll=Turbine.UI.Lotro.ScrollBar()
			RTVScroll:SetParent(RTLegend.Border)
			RTVScroll:SetSize(10,RTLegend.RTList:GetHeight());
			RTVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
			RTVScroll:SetPosition(rtWidth-12,RTLegend.RTList:GetTop());
			RTLegend.RTList:SetVerticalScrollBar(RTVScroll)
			RTLegend.Ping=Turbine.UI.Control();
			RTLegend.Ping:SetParent(mapWindow.Map);
			RTLegend.Ping:SetZOrder(topmost+1);
			RTLegend.Ping.State=0;
			RTLegend.Ping:SetVisible(false);
			RTLegend.Ping:SetSize(23,23);
			RTLegend.Ping:SetPosition(512,512);
			RTLegend.Ping:SetWantsUpdates(false);
			RTLegend.Ping.Counter=1;
			RTLegend.Ping.MaxCounter=2;
			RTLegend.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			RTLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
			RTLegend.Ping.MouseClick=function(sender,args)
				RTLegend.Ping.State=0; -- it will auto hide itmapWindow on next tick
			end
			RTLegend.Ping.Update=function(sender)
				if RTLegend.Ping.UpdateTime==nil then
					RTLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()-.01
				end
				if RTLegend.Ping.State==0 then
					RTLegend.Ping.UpdateTime=nil
					RTLegend.Ping:SetWantsUpdates(false);
					RTLegend.Ping:SetVisible(false);
					RTLegend.Ping.Counter=0;
					RTLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
				elseif Turbine.Engine:GetGameTime()>RTLegend.Ping.UpdateTime then
					RTLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()+.01
					if RTLegend.Ping.State==7 then
						RTLegend.Ping.Counter=RTLegend.Ping.Counter+1;
						if RTLegend.Ping.Counter>RTLegend.Ping.MaxCounter then
							RTLegend.Ping.Counter=0;
							RTLegend.Ping.State=3;
							RTLegend.Ping:SetBackground(resourcePath.."Ping3.tga");
						end
					else
						RTLegend.Ping.Counter=RTLegend.Ping.Counter+1;
						if RTLegend.Ping.Counter>RTLegend.Ping.MaxCounter then
							RTLegend.Ping.Counter=0;
							RTLegend.Ping.State=RTLegend.Ping.State+1;
							RTLegend.Ping:SetBackground(resourcePath.."Ping"..tostring(RTLegend.Ping.State)..".tga");
						end
					end
				end
			end
			RTLegend.SetUnchecked=function(index)
				-- if rtStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if rtStates[mapWindow.CurrentMapID]~=nil and rtStates[mapWindow.CurrentMapID][index]~=nil then
					local val=rtStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=RTLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription=Resource[Settings.language][501]
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Unchecked"..tostring(Settings.RTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Unchecked
				for k=1,RTLegend.RTList:GetItemCount() do
					local item=RTLegend.RTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/UncheckedIcon.tga")
						item.Title:SetText(Resource[Settings.language][501])
						break
					end
				end
				-- set rtStates[map][index] to nil
				if rtStates[mapWindow.CurrentMapID]==nil then rtStates[mapWindow.CurrentMapID]={} end
				rtStates[mapWindow.CurrentMapID][index]=nil
			end
			RTLegend.SetChecked=function(index)
				-- if rtStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if rtStates[mapWindow.CurrentMapID]~=nil and rtStates[mapWindow.CurrentMapID][index]~=nil then
					local val=rtStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=RTLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription=Resource[Settings.language][502]
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Checked"..tostring(Settings.RTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Checked
				for k=1,RTLegend.RTList:GetItemCount() do
					local item=RTLegend.RTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/CheckedIcon.tga")
						item.Title:SetText(Resource[Settings.language][502])
						break
					end
				end
				-- set rtStates[map][index] to 2
				if rtStates[mapWindow.CurrentMapID]==nil then rtStates[mapWindow.CurrentMapID]={} end
				rtStates[mapWindow.CurrentMapID][index]=2
			end
			RTLegend.SetActive=function(index,name)
				-- if rtStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if rtStates[mapWindow.CurrentMapID]==nil then rtStates[mapWindow.CurrentMapID]={} end
				local val=rtStates[mapWindow.CurrentMapID][index]
				local items=RTLegend.popupMenu:GetItems()
				for k=3,items:GetCount() do
					if type(val)=="string" then
						if items:Get(k).text==val then
							items:Get(k):SetEnabled(true)
						end
					end
					if items:Get(k).text==name then
						items:Get(k):SetEnabled(false)
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription=name
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Confirmed"..tostring(Settings.RTIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to name
				for k=1,RTLegend.RTList:GetItemCount() do
					local item=RTLegend.RTList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/ConfirmedIcon.tga")
						item.Title:SetText(name)
						break
					end
				end
				-- set rtStates[map][index] to name
				if rtStates[mapWindow.CurrentMapID]==nil then rtStates[mapWindow.CurrentMapID]={} end
				rtStates[mapWindow.CurrentMapID][index]=name
			end

			-- sort the list so that fixed values are at the top
			table.sort(RTLegend.RT,function(a,b) if a[1]<b[1] then return true end end)
			for rtIndex,rtData in ipairs(RTLegend.RT) do
				local tmpNode=Turbine.UI.Control()
				tmpNode.index=rtData[1]
				tmpNode:SetParent(RTLegend.RTList)
				tmpNode:SetSize(rtWidth-24,18)
				tmpNode.Icon=Turbine.UI.Control()
				tmpNode.Icon:SetParent(tmpNode)
				tmpNode.Icon:SetMouseVisible(false)
				tmpNode.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				tmpNode.Icon:SetSize(16,16)
				tmpNode.Title=Turbine.UI.Label()
				tmpNode.Title:SetParent(tmpNode)
				tmpNode.Title:SetSize(rtWidth-42,18)
				tmpNode.Title:SetLeft(18)
				tmpNode.Title:SetForeColor(Turbine.UI.Color.Red)
				tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
				tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
				tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
				local imgName="Unchecked"
				local state=1
				if rtData[2]==1 then
					if rtData[6]==2 then
						imgName="Checked"
						state=2
					elseif rtData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif rtData[2]==2 then
					-- this should only ever arise during testing
					if rtData[6]==2 then
						imgName="Checked"
						state=2
					elseif rtData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif rtData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				success,result=pcall(tmpNode.Icon.SetBackground,tmpNode.Icon,"GaranStuff/MoorMap/Overlays/RT/"..imgName.."Icon.tga")
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
					tmpNode.Title:SetText(rtData[5])

				if rtData[5]~=nil then
					tmpNode.Title:SetText(rtData[5])
				else
					local tmpName=Resource[Settings.language][501]
					-- set initial text based on state
					if rtStates[mapWindow.CurrentMapID]~=nil then
						if rtStates[mapWindow.CurrentMapID][tmpNode.index]~=nil then
							if rtStates[mapWindow.CurrentMapID][tmpNode.index]==2 then
								tmpName=Resource[Settings.language][502]
							elseif rtStates[mapWindow.CurrentMapID][tmpNode.index]==3 then
								tmpName=Resource[Settings.language][509]
							else
								tmpName=rtStates[mapWindow.CurrentMapID][tmpNode.index]
							end
						end
					end
					tmpNode.Title:SetText(tmpName)
				end
				tmpNode.X=math.floor(rtData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				tmpNode.Y=math.floor(rtData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
				tmpNode.Title:SetMouseVisible(false)
				if rtData[2]==1 then
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							RTLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							RTLegend.Ping.State=1;
							RTLegend.Ping:SetVisible(true);
							RTLegend.Ping:SetWantsUpdates(true);
						else
							-- pop up menu with choices to change state
							RTLegend.currentIndex=sender.index
							-- hide unavailable options
							local state=1
							if rtStates[mapWindow.CurrentMapID]~=nil then
								if rtStates[mapWindow.CurrentMapID][sender.index]~=nil then
									state=rtStates[mapWindow.CurrentMapID][sender.index]
								end
							end
							local items=RTLegend.popupMenu:GetItems()
							if state==1 then
								items:Get(1):SetEnabled(false)
								items:Get(2):SetEnabled(true)
							elseif state==2 then
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(false)
							else
								-- state will be the name of the currently selected bad guy
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(true)
							end
							local x,y=Turbine.UI.Display:GetMousePosition()
							RTLegend.popupMenu:ShowMenuAt(x,y)
						end
					end
				else
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							RTLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							RTLegend.Ping.State=1;
							RTLegend.Ping:SetVisible(true);
							RTLegend.Ping:SetWantsUpdates(true);
						end
					end
				end
				RTLegend.RTList:AddItem(tmpNode)
			end
		end
	end

	mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
	for itemIndex,itemData in ipairs(RTLegend.RT) do
			-- add the hotspot to the overlay
			if itemData[2]~=nil and itemData[3]~=nil and itemData[4]~=nil then
				local NS,EW=itemData[3],itemData[4]
				local X,Y
				X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);

				local tmpHotSpot=Turbine.UI.Control()
				tmpHotSpot.index=itemData[1]
				-- if the hotspots are on the overlay we don't get mouse events :(
				tmpHotSpot:SetParent(mapWindow.Map)
				tmpHotSpot:SetVisible(isvisible)
				tmpHotSpot:SetZOrder(topmost)

				tmpHotSpot:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				local imgName="Unchecked"
				local state=1
				if itemData[2]==1 then
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==2 then
					-- this should only ever arise during testing
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				tmpHotSpot:SetWidth(RTLegend.IconSize[Settings.RTIconSize][state][1])
				tmpHotSpot:SetHeight(RTLegend.IconSize[Settings.RTIconSize][state][2])
				success,result=pcall(tmpHotSpot.SetBackground,tmpHotSpot,"GaranStuff/MoorMap/Overlays/RT/"..imgName..tostring(Settings.RTIconSize)..".tga")
				tmpHotSpot:SetPosition(X-RTLegend.IconSize[Settings.RTIconSize][state][1]/2,Y-RTLegend.IconSize[Settings.RTIconSize][state][2]/2)
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
				if itemData[5]~=nil then
					tmpHotSpot.ShortDescription=itemData[5]
				else
					-- set initial text based on state
					tmpHotSpot.ShortDescription=Resource[Settings.language][501]
					if rtStates[mapWindow.CurrentMapID]~=nil then
						if rtStates[mapWindow.CurrentMapID][tmpHotSpot.index]~=nil then
							if rtStates[mapWindow.CurrentMapID][tmpHotSpot.index]==2 then
								tmpHotSpot.ShortDescription=Resource[Settings.language][502]
							elseif rtStates[mapWindow.CurrentMapID][tmpHotSpot.index]==3 then
								tmpHotSpot.ShortDescription=Resource[Settings.language][509]
							else
								tmpHotSpot.ShortDescription=rtStates[mapWindow.CurrentMapID][tmpHotSpot.index]
							end
						end
					end
				end
				if NS<0 then
					tmpHotSpot.Coords=string.format("%.1f",0-NS).."S "
				else
					tmpHotSpot.Coords=string.format("%.1f",NS).."N "
				end
				if EW<0 then
					tmpHotSpot.Coords=tmpHotSpot.Coords..string.format("%.1f",0-EW).."W"
				else
					tmpHotSpot.Coords=tmpHotSpot.Coords..string.format("%.1f",EW).."E"
				end
				if itemData[2]==1 then
					tmpHotSpot.MouseClick=function(sender,args)
						-- pop up menu with choices to change state
						RTLegend.currentIndex=sender.index
						-- hide unavailable options
						local state=1
						if rtStates[mapWindow.CurrentMapID]~=nil then
							if rtStates[mapWindow.CurrentMapID][sender.index]~=nil then
								state=rtStates[mapWindow.CurrentMapID][sender.index]
							end
						end
						local items=RTLegend.popupMenu:GetItems()
						if state==1 then
							items:Get(1):SetEnabled(false)
							items:Get(2):SetEnabled(true)
						elseif state==2 then
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(false)
						else
							-- state will be the name of the currently selected bad guy
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(true)
						end
						local x,y=Turbine.UI.Display:GetMousePosition()
						RTLegend.popupMenu:ShowMenuAt(x,y)
					end
				end
				tmpHotSpot.MouseHover=function(sender)
					RTHotSpotHover(sender)
				end
				table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
			end
	end
end