-- icons have three states, 0=unchecked, 1=checked & empty, 2=checked & active
-- note, fixed threats will always be state=2

tmp.WBScript=function(tmpData,tmpOLIndex)
	local success,result
	local topmost=100+#mapWindow.Map.Icons
	local isvisible=tmpData[8]
	local wbWidth=320
	local wbHeight=420
	if (WBLegend.WB==nil or WBLegend.WB[1]==nil) then
		WB={}
		legend={}
		success,result=pcall(import,importPath.."Overlays.WB.Data"..tostring(mapWindow.CurrentMapID));
		WBLegend.WB=WB
		if wbStates[mapWindow.CurrentMapID]~=nil then
			-- add state info from saved state
			for k,v in ipairs(WBLegend.WB) do
				-- note, it is imperative that the order of roving threat data does not change since it is tied to the custom states by the same index
				if wbStates[mapWindow.CurrentMapID][v[1]]~=nil then
					WBLegend.WB[k][6]=wbStates[mapWindow.CurrentMapID][v[1]]
				end
			end
		end
		if WBLegend.initialized==nil then
			WBLegend.VisibleChanged=function()
				if WBLegend:IsVisible() then
					-- add a nonsense string to the filter - this will cause all icons to be removed
					mapWindow.Map.IconSearch:SetText(mapWindow.Map.IconSearch:GetText()..string.char(10))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				else
					-- remove the nonsense string from the filter
					mapWindow.Map.IconSearch:SetText(string.gsub(mapWindow.Map.IconSearch:GetText(),string.char(10),""))
					mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
					filterBySearchText();
				end
			end
			WBLegend.popupMenu=Turbine.UI.ContextMenu()
			local tmpList=WBLegend.popupMenu:GetItems()
			local tmpItem=Turbine.UI.MenuItem("Set Unchecked")
			tmpItem.Click=function(sender)
				WBLegend.SetUnchecked(WBLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			tmpItem=Turbine.UI.MenuItem("Set Checked - No RT")
			tmpItem.Click=function(sender)
				WBLegend.SetChecked(WBLegend.currentIndex)
			end
			tmpList:Add(tmpItem)
			if WBLegend.WB.names~=nil then
				for k,v in ipairs(WBLegend.WB.names) do
					tmpItem=Turbine.UI.MenuItem(v)
					tmpItem.text=v
					if wbStates[mapWindow.CurrentMapID]~=nil then
						for index,data in pairs(wbStates[mapWindow.CurrentMapID]) do
							if data==v then
								tmpItem:SetEnabled(false)
								break
							end
						end
					end
					tmpItem.Click=function(sender)
						WBLegend.SetActive(WBLegend.currentIndex,sender.text)
					end
					tmpList:Add(tmpItem)
				end
			end

			WBLegend.initialized=true
			WBLegend.IconSize={}
			WBLegend.IconSize[16]={{26,16},{26,16},{26,16}}
			WBLegend.IconSize[24]={{38,24},{38,24},{38,24}}
			WBLegend.IconSize[32]={{51,32},{51,32},{51,32}}
			WBLegend.IconSize[40]={{64,40},{64,40},{64,40}}
			WBLegend.IconSize[48]={{77,48},{77,48},{77,48}}

			WBLegend:SetPosition(Settings.WBLegendLeftPercent*displayWidth,Settings.WBLegendTopPercent*displayHeight)
			if legend.width~=nil then
				wbWidth=legend.width
			end
			WBLegend:SetSize(wbWidth,wbHeight)
			WBLegend:SetZOrder(mapWindow:GetZOrder()+1)
			WBLegend:SetOpacity(.95)
			WBLegend:SetZOrder(2)
			WBLegend:SetStretchMode(3);
			RTVis=isvisible
			WBLegend:SetVisible(isvisible and mapWindow:IsVisible())
			WBLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			WBLegend.Border=Turbine.UI.Control()
			WBLegend.Border:SetParent(WBLegend)
			WBLegend.Border:SetSize(wbWidth-2,wbHeight-2)
			WBLegend.Border:SetPosition(1,1)
			if legend.backColor==nil then
				WBLegend.Border.backColor=Turbine.UI.Color(.95,.95,.85)
				WBLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
			else
				WBLegend.Border.backColor=legend.backColor
				WBLegend.Border:SetBackColor(legend.backColor)
			end
			WBLegend.TitleBack=Turbine.UI.Control()
			WBLegend.TitleBack:SetParent(WBLegend.Border)
			WBLegend.TitleBack:SetSize(wbWidth,65)
			WBLegend.Title=Turbine.UI.Control()
			WBLegend.Title:SetParent(WBLegend.TitleBack)
			WBLegend.Title:SetSize(250,65)
			WBLegend.Title:SetPosition((wbWidth-252)/2,1)
			WBLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if legend.caption==nil then
				WBLegend.Title:SetBackground(resourcePath.."RTCaptionMathwold.tga")
			else
				WBLegend.Title:SetBackground("GaranStuff/MoorMap/Overlays/"..legend.caption)
			end
			WBLegend.Title:SetMouseVisible(false)
			WBLegend.TitleBack.MouseDown=function(sender,args)
				local color=WBLegend.Border:GetBackColor()
				color.A=.8
				WBLegend.Border:SetBackColor(color)
				WBLegend.X=args.X
				WBLegend.Y=args.Y
				WBLegend.Moving=true
			end
			WBLegend.TitleBack.MouseMove=function(sender,args)
				if WBLegend.Moving then
					WBLegend:SetPosition(WBLegend:GetLeft()-(WBLegend.X-args.X),WBLegend:GetTop()-(WBLegend.Y-args.Y))
				end
			end
			WBLegend.TitleBack.MouseUp=function(sender,args)
				WBLegend.Border:SetBackColor(WBLegend.Border.backColor)
				WBLegend.Moving=false
			end
			WBLegend.TitleBack.MouseLeave=function(sender,args)
				WBLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
				WBLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			end
			WBLegend.TitleBack.MouseEnter=function(sender,args)
				WBLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
				WBLegend:SetBackColor(nil)
			end
			WBLegend.FontCaption=Turbine.UI.Label()
			WBLegend.FontCaption:SetParent(WBLegend.Border)
			WBLegend.FontCaption:SetSize(100,20)
			WBLegend.FontCaption:SetPosition(2,72)
			if legend.fontForeColor==nil then legend.fontForeColor=Turbine.UI.Color(.2,.5,.2) end
			WBLegend.FontCaption:SetForeColor(legend.fontForeColor)
			WBLegend.FontCaption:SetText(Resource[Settings.language][345]..":")
			if Settings.WBIconSize<48 then
				WBLegend.FontIncrease=Turbine.UI.Label()
				WBLegend.FontIncrease:SetParent(WBLegend.Border)
				WBLegend.FontIncrease:SetSize(20,20)
				WBLegend.FontIncrease:SetPosition(107,72)
				WBLegend.FontIncrease:SetForeColor(legend.fontForeColor)
				WBLegend.FontIncrease:SetText("+")
				WBLegend.FontIncrease.MouseClick=function(sender,args)
					Settings.WBIconSize=Settings.WBIconSize+8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end
			WBLegend.FontSizeCaption=Turbine.UI.Label()
			WBLegend.FontSizeCaption:SetParent(WBLegend.Border)
			WBLegend.FontSizeCaption:SetSize(40,20)
			WBLegend.FontSizeCaption:SetPosition(127,72)
			WBLegend.FontSizeCaption:SetForeColor(legend.fontForeColor)
			WBLegend.FontSizeCaption:SetText(Settings.WBIconSize)
			if Settings.WBIconSize>16 then
				WBLegend.FontDecrease=Turbine.UI.Label()
				WBLegend.FontDecrease:SetParent(WBLegend.Border)
				WBLegend.FontDecrease:SetSize(20,20)
				WBLegend.FontDecrease:SetPosition(167,72)
				WBLegend.FontDecrease:SetForeColor(legend.fontForeColor)
				WBLegend.FontDecrease:SetText("-")
				WBLegend.FontDecrease.MouseClick=function(sender,args)
					Settings.WBIconSize=Settings.WBIconSize-8
					mapWindow.PreserveMapID=true;
					Turbine.PluginManager.LoadPlugin("MoorMapLoader");
				end
			end

			WBLegend.WBList=Turbine.UI.ListBox()
			WBLegend.WBList:SetParent(WBLegend.Border)
			WBLegend.WBList:SetSize(wbWidth-24,wbHeight-92)
			WBLegend.WBList:SetPosition(5,90)
			RTVScroll=Turbine.UI.Lotro.ScrollBar()
			RTVScroll:SetParent(WBLegend.Border)
			RTVScroll:SetSize(10,WBLegend.WBList:GetHeight());
			RTVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
			RTVScroll:SetPosition(wbWidth-12,WBLegend.WBList:GetTop());
			WBLegend.WBList:SetVerticalScrollBar(RTVScroll)
			WBLegend.Ping=Turbine.UI.Control();
			WBLegend.Ping:SetParent(mapWindow.Map);
			WBLegend.Ping:SetZOrder(topmost+1);
			WBLegend.Ping.State=0;
			WBLegend.Ping:SetVisible(false);
			WBLegend.Ping:SetSize(23,23);
			WBLegend.Ping:SetPosition(512,512);
			WBLegend.Ping:SetWantsUpdates(false);
			WBLegend.Ping.Counter=1;
			WBLegend.Ping.MaxCounter=2;
			WBLegend.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			WBLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
			WBLegend.Ping.MouseClick=function(sender,args)
				WBLegend.Ping.State=0; -- it will auto hide itmapWindow on next tick
			end
			WBLegend.Ping.Update=function(sender)
				if WBLegend.Ping.UpdateTime==nil then
					WBLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()-.01
				end
				if WBLegend.Ping.State==0 then
					WBLegend.Ping:SetWantsUpdates(false);
					WBLegend.Ping:SetVisible(false);
					WBLegend.Ping.Counter=0;
					WBLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
				elseif Turbine.Engine:GetGameTime()>WBLegend.Ping.UpdateTime then
					WBLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()+.01
					if WBLegend.Ping.State==7 then
						WBLegend.Ping.Counter=WBLegend.Ping.Counter+1;
						if WBLegend.Ping.Counter>WBLegend.Ping.MaxCounter then
							WBLegend.Ping.Counter=0;
							WBLegend.Ping.State=3;
							WBLegend.Ping:SetBackground(resourcePath.."Ping3.tga");
						end
					else
						WBLegend.Ping.Counter=WBLegend.Ping.Counter+1;
						if WBLegend.Ping.Counter>WBLegend.Ping.MaxCounter then
							WBLegend.Ping.Counter=0;
							WBLegend.Ping.State=WBLegend.Ping.State+1;
							WBLegend.Ping:SetBackground(resourcePath.."Ping"..tostring(WBLegend.Ping.State)..".tga");
						end
					end
				end
			end
			WBLegend.SetUnchecked=function(index)
				-- if wbStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if wbStates[mapWindow.CurrentMapID]~=nil and wbStates[mapWindow.CurrentMapID][index]~=nil then
					local val=wbStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=WBLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription="Unchecked"
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Unchecked"..tostring(Settings.WBIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Unchecked
				for k=1,WBLegend.WBList:GetItemCount() do
					local item=WBLegend.WBList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/UncheckedIcon.tga")
						item.Title:SetText("Unchecked")
						break
					end
				end
				-- set wbStates[map][index] to nil
				if wbStates[mapWindow.CurrentMapID]==nil then wbStates[mapWindow.CurrentMapID]={} end
				wbStates[mapWindow.CurrentMapID][index]=nil
			end
			WBLegend.SetChecked=function(index)
				-- if wbStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if wbStates[mapWindow.CurrentMapID]~=nil and wbStates[mapWindow.CurrentMapID][index]~=nil then
					local val=wbStates[mapWindow.CurrentMapID][index]
					if type(val)=="string" then
						local items=WBLegend.popupMenu:GetItems()
						for k=3,items:GetCount() do
							if items:Get(k).text==val then
								items:Get(k):SetEnabled(true)
								break
							end
						end
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription="Checked"
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Checked"..tostring(Settings.WBIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to Checked
				for k=1,WBLegend.WBList:GetItemCount() do
					local item=WBLegend.WBList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/CheckedIcon.tga")
						item.Title:SetText("Checked")
						break
					end
				end
				-- set wbStates[map][index] to 2
				if wbStates[mapWindow.CurrentMapID]==nil then wbStates[mapWindow.CurrentMapID]={} end
				wbStates[mapWindow.CurrentMapID][index]=2
			end
			WBLegend.SetActive=function(index,name)
				-- if wbStates[ma][index]==a string, restore the matching name to the menu list and dropdown list
				if wbStates[mapWindow.CurrentMapID]==nil then wbStates[mapWindow.CurrentMapID]={} end
				local val=wbStates[mapWindow.CurrentMapID][index]
				local items=WBLegend.popupMenu:GetItems()
				for k=3,items:GetCount() do
					if type(val)=="string" then
						if items:Get(k).text==val then
							items:Get(k):SetEnabled(true)
						end
					end
					if items:Get(k).text==name then
						items:Get(k):SetEnabled(false)
					end
				end
				-- set the hotspot shortdescription and icon
				for k,v in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
					if v.index==index then
						v.ShortDescription=name
						success,result=pcall(v.SetBackground,v,"GaranStuff/MoorMap/Overlays/RT/Confirmed"..tostring(Settings.WBIconSize)..".tga")
						break
					end
				end
				-- change the dropdown list text to name
				for k=1,WBLegend.WBList:GetItemCount() do
					local item=WBLegend.WBList:GetItem(k)
					if item.index==index then
						success,result=pcall(item.Icon.SetBackground,item.Icon,"GaranStuff/MoorMap/Overlays/RT/ConfirmedIcon.tga")
						item.Title:SetText(name)
						break
					end
				end
				-- set wbStates[map][index] to name
				if wbStates[mapWindow.CurrentMapID]==nil then wbStates[mapWindow.CurrentMapID]={} end
				wbStates[mapWindow.CurrentMapID][index]=name
			end

			-- sort the list so that fixed values are at the top
			table.sort(WBLegend.WB,function(a,b) if a[1]<b[1] then return true end end)
			for rtIndex,rtData in ipairs(WBLegend.WB) do
				local tmpNode=Turbine.UI.Control()
				tmpNode.index=rtData[1]
				tmpNode:SetParent(WBLegend.WBList)
				tmpNode:SetSize(wbWidth-24,18)
				tmpNode.Icon=Turbine.UI.Control()
				tmpNode.Icon:SetParent(tmpNode)
				tmpNode.Icon:SetMouseVisible(false)
				tmpNode.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				tmpNode.Icon:SetSize(16,16)
				tmpNode.Title=Turbine.UI.Label()
				tmpNode.Title:SetParent(tmpNode)
				tmpNode.Title:SetSize(wbWidth-42,18)
				tmpNode.Title:SetLeft(18)
				tmpNode.Title:SetForeColor(Turbine.UI.Color.Red)
				tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
				tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
				tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
				local imgName="Unchecked"
				local state=1
				if rtData[2]==1 then
					if rtData[6]==2 then
						imgName="Checked"
						state=2
					elseif rtData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif rtData[2]==2 then
					-- this should only ever arise during testing
					if rtData[6]==2 then
						imgName="Checked"
						state=2
					elseif rtData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif rtData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				success,result=pcall(tmpNode.Icon.SetBackground,tmpNode.Icon,"GaranStuff/MoorMap/Overlays/RT/"..imgName.."Icon.tga")
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
					tmpNode.Title:SetText(rtData[5])

				if rtData[5]~=nil then
					tmpNode.Title:SetText(rtData[5])
				else
					local tmpName="Unchecked"
					-- set initial text based on state
					if wbStates[mapWindow.CurrentMapID]~=nil then
						if wbStates[mapWindow.CurrentMapID][tmpNode.index]~=nil then
							if wbStates[mapWindow.CurrentMapID][tmpNode.index]==2 then
								tmpName="Checked"
							else
								tmpName=wbStates[mapWindow.CurrentMapID][tmpNode.index]
							end
						end
					end
					tmpNode.Title:SetText(tmpName)
				end
				tmpNode.X=math.floor(rtData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				tmpNode.Y=math.floor(rtData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
--				if NS<0 then
--					tmpHotSpot.Coords=tostring(0-NS).."S, "
--				else
--					tmpHotSpot.Coords=tostring(NS).."N, "
--				end
--				if EW<0 then
--					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
--				else
--					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
--				end
				tmpNode.Title:SetMouseVisible(false)
				if rtData[2]==1 then
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							WBLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							WBLegend.Ping.State=1;
							WBLegend.Ping:SetVisible(true);
							WBLegend.Ping:SetWantsUpdates(true);
						else
							-- pop up menu with choices to change state
							WBLegend.currentIndex=sender.index
							-- hide unavailable options
							local state=1
							if wbStates[mapWindow.CurrentMapID]~=nil then
								if wbStates[mapWindow.CurrentMapID][sender.index]~=nil then
									state=wbStates[mapWindow.CurrentMapID][sender.index]
								end
							end
							local items=WBLegend.popupMenu:GetItems()
							if state==1 then
								items:Get(1):SetEnabled(false)
								items:Get(2):SetEnabled(true)
							elseif state==2 then
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(false)
							else
								-- state will be the name of the currently selected bad guy
								items:Get(1):SetEnabled(true)
								items:Get(2):SetEnabled(true)
							end
							local x,y=Turbine.UI.Display:GetMousePosition()
							WBLegend.popupMenu:ShowMenuAt(x,y)
						end
					end
				else
					tmpNode.MouseClick=function(sender,args)
						if args.Button==1 then
							-- ping
							WBLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
							WBLegend.Ping.State=1;
							WBLegend.Ping:SetVisible(true);
							WBLegend.Ping:SetWantsUpdates(true);
						end
					end
				end
				WBLegend.WBList:AddItem(tmpNode)
			end
		end
	end

	mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
	for itemIndex,itemData in ipairs(WBLegend.WB) do
			-- add the hotspot to the overlay
			if itemData[2]~=nil and itemData[3]~=nil and itemData[4]~=nil then
				local NS,EW=itemData[3],itemData[4]
				local X,Y
				X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-Settings.WBIconSize/2;
				Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-Settings.WBIconSize/2;

				local tmpHotSpot=Turbine.UI.Control()
				tmpHotSpot.index=itemData[1]
				-- if the hotspots are on the overlay we don't get mouse events :(
				tmpHotSpot:SetParent(mapWindow.Map)
				tmpHotSpot:SetVisible(isvisible)
				tmpHotSpot:SetZOrder(topmost)

				tmpHotSpot:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				local imgName="Unchecked"
				local state=1
				if itemData[2]==1 then
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==2 then
					-- this should only ever arise during testing
					if itemData[6]==2 then
						imgName="Checked"
						state=2
					elseif itemData[6]~=nil then
						imgName="Confirmed"
						state=3
					end
				elseif itemData[2]==3 then
					-- this is a fixed location threat and will always be present
					imgName="Confirmed"
					state=3
				end
				tmpHotSpot:SetWidth(WBLegend.IconSize[Settings.WBIconSize][state][1])
				tmpHotSpot:SetHeight(WBLegend.IconSize[Settings.WBIconSize][state][2])
				success,result=pcall(tmpHotSpot.SetBackground,tmpHotSpot,"GaranStuff/MoorMap/Overlays/RT/"..imgName..tostring(Settings.WBIconSize)..".tga")
				tmpHotSpot:SetPosition(X,Y)
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
				if itemData[5]~=nil then
					tmpHotSpot.ShortDescription=itemData[5]
				else
					-- set initial text based on state
					tmpHotSpot.ShortDescription="Unchecked"
					if wbStates[mapWindow.CurrentMapID]~=nil then
						if wbStates[mapWindow.CurrentMapID][tmpHotSpot.index]~=nil then
							if wbStates[mapWindow.CurrentMapID][tmpHotSpot.index]==2 then
								tmpHotSpot.ShortDescription="Checked"
							else
								tmpHotSpot.ShortDescription=wbStates[mapWindow.CurrentMapID][tmpHotSpot.index]
							end
						end
					end
				end
				if NS<0 then
					tmpHotSpot.Coords=tostring(0-NS).."S, "
				else
					tmpHotSpot.Coords=tostring(NS).."N, "
				end
				if EW<0 then
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
				else
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
				end
				if itemData[2]==1 then
					tmpHotSpot.MouseClick=function(sender,args)
						-- pop up menu with choices to change state
						WBLegend.currentIndex=sender.index
						-- hide unavailable options
						local state=1
						if wbStates[mapWindow.CurrentMapID]~=nil then
							if wbStates[mapWindow.CurrentMapID][sender.index]~=nil then
								state=wbStates[mapWindow.CurrentMapID][sender.index]
							end
						end
						local items=WBLegend.popupMenu:GetItems()
						if state==1 then
							items:Get(1):SetEnabled(false)
							items:Get(2):SetEnabled(true)
						elseif state==2 then
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(false)
						else
							-- state will be the name of the currently selected bad guy
							items:Get(1):SetEnabled(true)
							items:Get(2):SetEnabled(true)
						end
						local x,y=Turbine.UI.Display:GetMousePosition()
						WBLegend.popupMenu:ShowMenuAt(x,y)
					end
				end
--				tmpHotSpot.MouseEnter=function(sender)
--					sender.Text:SetBackColor(Turbine.UI.Color(.9,.9,.9))
--				end
--				tmpHotSpot.MouseLeave=function(sender)
--					sender.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
--				end
				tmpHotSpot.MouseHover=function(sender)
					RTHotSpotHover(sender)
				end
				table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
			end
	end
end