if importPath==nil then importPath=string.gsub(getfenv(1)._.Name,"%.Search","").."." end
if resourcePath==nil then resourcePath=string.gsub(importPath,"%.","/").."Resources/" end

-- uses the command "0MMP_Type_MapID_CurrMapID_worldName_searchText" to pass search parameter to the plugin which processes the search
-- the processing plugin will create a "0MMR_NS_EW_MapID_Title_Description" command for each result that it identifies
-- the search plugin will remove the "Result" command(s) each time it unloads - the unload is triggered by this plugin once the search plugin generates a "0MMC" completion command
-- after each map is searched, this plugin will change the SearchParms command, repeating until all maps are searched
-- I have to reload the search for each map in order to read the custom annotations for each map (default annotations are read from the .lua files and could be all read by a single plugin instance)

-- note, the "0" at the start of the command name is to avoid scanning all legit commands when looking for a parameter or result

-- states:
-- 1=ready to search map, MMSearch not yet loaded
-- 2=searching map, waiting for MMSearch to load
-- 3=MMSearch loaded, waiting for 0MMC
-- 4=0MMC received, waiting for MMSearch to unload
-- 5=completed all maps, searching current custom annotations and exiting

replaceStr={[128]="A",[129]="A",[130]="A",[131]="A",[132]="A",[133]="A",[134]="AE",[135]="C",[136]="E",[137]="E",[138]="E",[139]="E",[140]="I",[141]="I",[142]="I",[143]="I",[144]="",[145]="N",[146]="O",[147]="O",[148]="O",[149]="O",[150]="O",[151]="",[152]="O",[153]="U",[154]="U",[155]="U",[156]="U",[157]="Y",[158]="Y",[159]="sz",[160]="a",[161]="a",[162]="a",[163]="a",[164]="a",[165]="a",[166]="ae",[167]="c",[168]="e",[169]="e",[170]="e",[171]="e",[172]="i",[173]="i",[174]="i",[175]="i",[176]="o",[177]="n",[178]="o",[179]="o",[180]="o",[181]="o",[182]="o",[183]="",[184]="o",[185]="u",[186]="u",[187]="u",[188]="u",[189]="y",[190]="y",[191]="y"}
string.stripaccent=function(str)
	local ret = "";
	if str~=nil then
		ret=""
		local replace=false
		for i,v in ipairs({str:byte(1,-1)}) do
			if replace then
				replace=false
				if replaceStr[v]~=nil then
					ret=ret..replaceStr[v]
				end
			else
				if (v==195) then
					replace=true
				else
					ret = ret .. string.char(v);
				end
			end
		end
	end
	return ret;
end
string.encode=function(str)
	-- replace all non-alpha characters with a % escaped hex code
	local ret=""
	for i,v in ipairs({str:byte(1,-1)}) do
		if (v < 48) or (v>57 and v<65) or (v>90 and v<97) or (v > 125) then
			ret = ret .. "%" .. string.sub("00"..string.format("%x",tonumber(v)),-2)
		else
			ret = ret .. string.char(v)
		end
	end
	return ret
end
string.decode=function(str)
	local ret=""
	while string.len(str)~=0 do
		local char=string.sub(str,1,1)
		if char~="%" then
			ret=ret..char
			str=string.sub(str,2,-1)
		else
			local char=string.char(tonumber("0x"..string.sub(str,2,3)))
			ret=ret..char
			str = string.sub(str,4,-1)
		end
	end
	return ret;
end

searchWindow=Turbine.UI.Lotro.Window()
searchWindow:SetText(Resource[Settings.language][220])
searchWindow:SetSize(600,400)
searchWindow:SetPosition((Turbine.UI.Display:GetWidth()-searchWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-searchWindow:GetHeight())/2)
searchWindow:SetZOrder(3)

searchWindow.searchCaption=Turbine.UI.Label()
searchWindow.searchCaption:SetParent(searchWindow)
searchWindow.searchCaption:SetSize(100,20)
searchWindow.searchCaption:SetPosition(10,45)
searchWindow.searchCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18)
searchWindow.searchCaption:SetText(Resource[Settings.language][220]..":")
searchWindow.searchText=Turbine.UI.Lotro.TextBox()
searchWindow.searchText:SetParent(searchWindow)
searchWindow.searchText:SetSize(300,20)
searchWindow.searchText:SetPosition(110,45)
searchWindow.searchText:SetFont(Turbine.UI.Lotro.Font.Verdana16)
searchWindow.searchText:SetMultiline(false)
searchWindow.searchText.FocusGained=function()
	searchWindow.searchText:SetWantsKeyEvents(true)
end
searchWindow.searchText.FocusLost=function() searchWindow.searchText:SetWantsKeyEvents(false) end
searchWindow.searchText.KeyDown=function(sender,args)
	if args.Action==162 then
		searchWindow.searchText:SetWantsKeyEvents(false)
		searchWindow.cmdSearch:Focus()
		searchWindow.cmdSearch.Click()
	end
end
searchWindow.searchOpt1=RadioButtonGroup()
searchWindow.searchOpt1:SetParent(searchWindow);
searchWindow.searchOpt1:SetSize(searchWindow:GetWidth()-20,20);
searchWindow.searchOpt1:SetPosition(10,searchWindow.searchCaption:GetTop()+searchWindow.searchCaption:GetHeight()+5);
searchWindow.searchOpt1.UnselectedIcon=resourcePath.."RB_unselected.tga";
searchWindow.searchOpt1.SelectedIcon=resourcePath.."RB_selected.tga";
searchWindow.searchOpt1.IconWidth=16;
searchWindow.searchOpt1.IconHeight=16;
searchWindow.searchOpt1:SetBorderColor(backColor);
searchWindow.searchOpt1:SetBackColor(backColor);
searchWindow.searchOpt1:SetTextColor(fontColor);
searchWindow.searchOpt1:AddChoice(Resource[Settings.language][352]);
searchWindow.searchOpt1:AddChoice(Resource[Settings.language][353]);
searchWindow.searchOpt1:AddChoice(Resource[Settings.language][354]);
searchWindow.searchOpt1:SetRows(1);
searchWindow.searchOpt1:SetSelectedChoice(1);

searchWindow.resultHeader=Turbine.UI.Control()
searchWindow.resultHeader:SetParent(searchWindow)
searchWindow.resultHeader:SetSize(searchWindow:GetWidth()-20,20)
searchWindow.resultHeader:SetPosition(10,105)
searchWindow.resultHeader1=Turbine.UI.Label()
searchWindow.resultHeader1:SetParent(searchWindow.resultHeader)
searchWindow.resultHeader1:SetSize(240,20)
searchWindow.resultHeader1:SetFont(Turbine.UI.Lotro.Font.Verdana14)
searchWindow.resultHeader1:SetPosition(0,0)
searchWindow.resultHeader1:SetBackColor(Turbine.UI.Color.DarkBlue)
searchWindow.resultHeader1:SetText(Resource[Settings.language][77])

searchWindow.resultHeader2=Turbine.UI.Label()
searchWindow.resultHeader2:SetParent(searchWindow.resultHeader)
searchWindow.resultHeader2:SetSize(200,20)
searchWindow.resultHeader2:SetPosition(240,0)
searchWindow.resultHeader2:SetBackColor(Turbine.UI.Color.DarkBlue)
searchWindow.resultHeader2:SetFont(Turbine.UI.Lotro.Font.Verdana14)
searchWindow.resultHeader2:SetText(Resource[Settings.language][224])

searchWindow.resultHeader3=Turbine.UI.Label()
searchWindow.resultHeader3:SetParent(searchWindow.resultHeader)
searchWindow.resultHeader3:SetSize(searchWindow.resultHeader:GetWidth()-440,20)
searchWindow.resultHeader3:SetFont(Turbine.UI.Lotro.Font.Verdana14)
searchWindow.resultHeader3:SetPosition(440,0)
searchWindow.resultHeader3:SetBackColor(Turbine.UI.Color.DarkBlue)
searchWindow.resultHeader3:SetText(Resource[Settings.language][355])

searchWindow.resultList=Turbine.UI.ListBox()
searchWindow.resultList:SetParent(searchWindow)
searchWindow.resultList:SetSize(searchWindow:GetWidth()-30,searchWindow:GetHeight()-172)
searchWindow.resultList:SetPosition(10,122)
searchWindow.resultList:SetBackColor(Turbine.UI.Color.Black)

searchWindow.resultVScroll=Turbine.UI.Lotro.ScrollBar()
searchWindow.resultVScroll:SetParent(searchWindow)
searchWindow.resultVScroll:SetSize(10,searchWindow.resultList:GetHeight())
searchWindow.resultVScroll:SetPosition(searchWindow.resultList:GetWidth()+10,searchWindow.resultList:GetTop())
searchWindow.resultVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
searchWindow.resultList:SetVerticalScrollBar(searchWindow.resultVScroll)

searchWindow.noItems=Turbine.UI.Label()
searchWindow.noItems:SetParent(searchWindow)
searchWindow.noItems:SetZOrder(1)
searchWindow.noItems:SetSize(searchWindow.resultList:GetSize())
searchWindow.noItems:SetPosition(searchWindow.resultList:GetPosition())
searchWindow.noItems:SetText("No matching NPCs or locations")
searchWindow.noItems:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter)
searchWindow.noItems:SetVisible(false)

searchWindow.cmdSearch=Turbine.UI.Lotro.Button()
searchWindow.cmdSearch:SetParent(searchWindow)
searchWindow.cmdSearch:SetSize(100,20)
searchWindow.cmdSearch:SetPosition((searchWindow:GetWidth()-searchWindow.cmdSearch:GetWidth())/2,searchWindow:GetHeight()-45)
searchWindow.cmdSearch:SetFont(Turbine.UI.Lotro.Font.Verdana18)
searchWindow.cmdSearch:SetText(Resource[Settings.language][220])
searchWindow.cmdSearch.Click=function()
-- initialize the search process and display the status window
	local tmpText=searchWindow.searchText:GetText()
	if tmpText~="" then
		searchWindow.resultList:ClearItems()
		searchWindow.results={} -- create empty table
		searchWindow.mapID=1
		searchWindow.state=1
		statusDisplay:SetVisible(true);
		searchWindow:SetWantsUpdates(true)
	end
end

searchWindow.Update=function()
-- loop through all maps
-- state:0=not ready, 1=ready, 2=waiting on MMSearch, 3=waiting on 0MMC, 4=waiting for MMSearch to unload, 5=ready to search curr & display
	if searchWindow.state==2 then
		-- search active plugins for "MMSearch"
		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		local pluginIndex;
		for pluginIndex=1,#tmpPlugins do
			if tmpPlugins[pluginIndex].Name=="MMSearch" then
				searchWindow.state=3
				break;
			end
		end
	end
	if searchWindow.state==3 then
		-- check for search completion
		local cmds=Turbine.Shell.GetCommands();
		if Turbine.Shell.IsCommand("0MMC") then
			if cmds~=nil and type(cmds)=="table" then
				if cmds[0]~=nil then
					-- note, there is a bug that can cause GetCommands to return a 0 based array which won't always sort correctly
					table.insert(cmds,cmds[0])
					cmds[0]=nil
				end
				table.sort(cmds,function(arg1,arg2)if arg1<arg2 then return(true) end end);
			end
			for cmdIndex=1,#cmds do
				if cmds[cmdIndex]>="1" then
					break
				else
					local result=string.match(cmds[cmdIndex],"0MMR_(.*)");
					if result~=nil then
						result=string.split(result,"_")
						result[1]=tonumber(result[1])
						result[2]=tonumber(result[2])
						result[3]=tonumber(result[3])
						if result[1]==nil then result[1]=1 end
						if result[2]==nil then result[2]=0 end
						if result[3]==nil then result[3]=0 end
						if result[4]==nil then result[4]="" end
						if result[5]==nil then result[5]="" end
						result[4]=string.decode(result[4])
						result[5]=string.decode(result[5])
						table.insert(searchWindow.results,{mapInfo[result[1]][12],mapInfo[result[1]][17],result[2],result[3],result[1],Resource[Settings.language][mapInfo[result[1]][2]],result[4],result[5]})
					end
				end
			end
			Turbine.PluginManager.UnloadScriptState("MMSearch"); -- don't unload until the commands are processed as the unload event removes the commands
			searchWindow.mapID=searchWindow.mapID+1
			searchWindow.state=4
			if searchWindow.mapID>#mapInfo then
				searchWindow.state=5 -- last map processed, search current custom annots and display
			end
		end
	end
	if searchWindow.state==4 then
		local found=false
		-- search active plugins for "MMSearch"
		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		local pluginIndex;
		for pluginIndex=1,#tmpPlugins do
			if tmpPlugins[pluginIndex].Name=="MMSearch" then
				found=true
				break;
			end
		end
		if not found then
			searchWindow.state=1
		end
	end

	if searchWindow.state==1 then
		searchWindow.state=2
		statusDisplay.MapText:SetText(Resource[Settings.language][mapInfo[searchWindow.mapID][2]]);
		-- start processing next map
		local tmpText=string.lower(string.stripaccent(searchWindow.searchText:GetText()))
		if tmpText~="" then
			-- register the search parm command
			if searchCmd~=nil then
				Turbine.Shell.RemoveCommand(searchCmd); -- remove prior cmd
				searchCmd=nil
			end
			searchCmd=Turbine.ShellCommand()
			searchWindow:SetWantsUpdates(true)
			Turbine.Shell.AddCommand("0MMP_"..tostring(searchWindow.searchOpt1:GetSelectedChoice()).."_"..tostring(searchWindow.mapID).."_"..tostring(LoadedMapID).."_"..tostring(worldName).."_"..string.encode(string.lower(tmpText)),searchCmd); -- this is automatically removed in the unload event handler
			Turbine.PluginManager.LoadPlugin("MMSearch");
		end
	end
	if searchWindow.state==5 then
		statusDisplay.MapText:SetText("Formatting Results");
		if searchCmd~=nil then
			Turbine.Shell.RemoveCommand(searchCmd); -- remove prior cmd
			searchCmd=nil
		end
		searchWindow:SetWantsUpdates(false)
		-- now add any matches from current map custom annots
		if searchWindow.searchOpt1:GetSelectedChoice()==2 or searchWindow.searchOpt1:GetSelectedChoice()==3 then
			local searchName=string.lower(string.stripaccent(searchWindow.searchText:GetText()))
			for k,v in pairs(annotations) do
				if v[6]==nil and v[1]==LoadedMapID then
					-- this is a custom annotation
					if string.find(string.lower(string.stripaccent(v[7])),searchName)~=nil then
						result=string.split(v[7],":")
						table.insert(searchWindow.results,{mapInfo[LoadedMapID][12],mapInfo[LoadedMapID][17],v[2],v[3],LoadedMapID,Resource[Settings.language][mapInfo[LoadedMapID][2]],result[1],result[2]})
					end
				end
			end
		end

		-- sort by region, name, ns, ew, mapTier
		table.sort(searchWindow.results,function(arg1,arg2) if arg1[1]<arg2[1] then return true elseif arg1[1]==arg2[1] then if arg1[7]<arg2[7] then return true elseif arg1[7]==arg2[7] then if arg1[3]<arg2[3] then return true elseif arg1[3]==arg2[3] then if arg1[4]<arg2[4] then return true elseif arg1[4]==arg2[4] then if arg1[2]>arg2[2] then return true end end end end end end) -- sort on map then name then ns then ew
		-- now eliminate any duplicates
		local tmpIndex=2
		local max=#searchWindow.results
		while tmpIndex<=max do
			if searchWindow.results[tmpIndex][7]==searchWindow.results[tmpIndex-1][7] and searchWindow.results[tmpIndex][3]==searchWindow.results[tmpIndex-1][3] and searchWindow.results[tmpIndex][4]==searchWindow.results[tmpIndex-1][4] and searchWindow.results[tmpIndex][1]==searchWindow.results[tmpIndex-1][1] then
				-- same ns, ew, name and region
				table.remove(searchWindow.results,tmpIndex)
				max=max-1
			else
				tmpIndex=tmpIndex+1
			end
		end
		-- now re-sort by map, name, ns, ew
		table.sort(searchWindow.results,function(arg1,arg2) if arg1[6]<arg2[6] then return true elseif arg1[6]==arg2[6] then if arg1[7]<arg2[7] then return true elseif arg1[7]==arg2[7] then if arg1[3]<arg2[3] then return true elseif arg1[3]==arg2[3] then if arg1[4]<arg2[4] then return true end end end end end) -- sort on map then name then ns then ew

		for k,v in ipairs(searchWindow.results) do
			searchWindow.AddSearchResult(v[5],v[3],v[4],v[7],v[6],v[8]) -- mapid,ns,ew,name,mapName,desc
		end
		searchWindow.noItems:SetVisible((#searchWindow.results==0))
		statusDisplay:SetVisible(false)
	end
end
searchWindow.AddSearchResult=function(mapID,ns,ew,name,mapName,description)
	local tmpItem=Turbine.UI.Control()
	tmpItem:SetParent(searchWindow.resultList)
	tmpItem:SetSize(searchWindow.resultList:GetWidth(),20)
	tmpItem.mapID=tonumber(mapID)
	tmpItem.ns=tonumber(ns)
	tmpItem.ew=tonumber(ew)
	tmpItem.name=name
	tmpItem.description=description

	tmpItem.tmpName=Turbine.UI.Label()
	tmpItem.tmpName:SetParent(tmpItem)
	tmpItem.tmpName:SetSize(240,20)
	tmpItem.tmpName:SetText(name)
	tmpItem.tmpName:SetMouseVisible(false)

	tmpItem.tmpMap=Turbine.UI.Label()
	tmpItem.tmpMap:SetParent(tmpItem)
	tmpItem.tmpMap:SetSize(200,20)
	tmpItem.tmpMap:SetLeft(240)
	tmpItem.tmpMap:SetText(mapName)
	tmpItem.tmpMap:SetMouseVisible(false)

	local tmpStr
	if tmpItem.ns<0 then
		tmpStr=tostring(0-tmpItem.ns).." S, "
	else
		tmpStr=tostring(tmpItem.ns).." N, "
	end
	if tmpItem.ew<0 then
		tmpStr=tmpStr..tostring(0-tmpItem.ew).." W"
	else
		tmpStr=tmpStr..tostring(tmpItem.ew).." E"
	end
	tmpItem.tmpCoords=Turbine.UI.Label()
	tmpItem.tmpCoords:SetParent(tmpItem)
	tmpItem.tmpCoords:SetSize(120,20)
	tmpItem.tmpCoords:SetLeft(440)
	tmpItem.tmpCoords:SetText(tmpStr)
	tmpItem.tmpCoords:SetSelectable(true)
--	tmpItem.tmpCoords:SetMouseVisible(false)

	tmpItem.MouseClick=function(sender,args)
		mapWindow.shellCmd.Execute(mapWindow, "moormap", "ping "..tostring(sender.mapID)..":"..tostring(sender.ns)..":"..tostring(sender.ew)..":"..sender.name..":"..tostring(sender.description))
	end
	searchWindow.resultList:AddItem(tmpItem)
end

statusDisplay=Turbine.UI.Lotro.Window();
statusDisplay:SetSize(400,100);
statusDisplay:SetPosition((Turbine.UI.Display:GetWidth() - statusDisplay:GetWidth())/2,(Turbine.UI.Display:GetHeight() - statusDisplay:GetHeight())/2)
statusDisplay:SetText(Resource[Settings.language][356]);
statusDisplay.Status=Resource[Settings.language][357];
statusDisplay.StatusText=Turbine.UI.Label();
statusDisplay.StatusText:SetParent(statusDisplay);
statusDisplay.StatusText:SetSize(200,18);
statusDisplay.StatusText:SetPosition((statusDisplay:GetWidth()-statusDisplay.StatusText:GetWidth())/2,40);
statusDisplay.StatusText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
statusDisplay.StatusText:SetText(statusDisplay.Status);

statusDisplay.MapText=Turbine.UI.Label();
statusDisplay.MapText:SetParent(statusDisplay);
statusDisplay.MapText:SetSize(200,18);
statusDisplay.MapText:SetPosition((statusDisplay:GetWidth()-statusDisplay.MapText:GetWidth())/2,60);
statusDisplay.MapText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

statusDisplay:SetZOrder(searchWindow:GetZOrder()+1);

searchWindow.SetFontColor=function()
end
searchWindow.SetTrimColor=function()
end
searchWindow.SetBackColor=function()
end
searchWindow.SetHeadingsColor=function()
end
searchWindow.SetListTextColor=function()
end
